<?php
/**
 *  Fonctions PHP pour le contrle des valeurs saisies dans les champs des formulaires.
 *  Ces fonctions sont ajoutes par scurit en plus des contrles Javascript ct client.
 *
 **/

// Cette fonction est charge de vrifier que la cl primaire du tuple que l'on veut insrer n'est pas dj prsente dans la table.
function verifClePrim($nom_table,$liste_col_cles){
	global $connection;
	global $bool_ctrl;
	global $mess_ctrl;
	global $la;
	$select = "SELECT ";
	$from = " FROM ".$nom_table;
	$where = " WHERE ";
	$mess_tmp = labelLang("erreur_doublon_cleprim","message_interface",$la);
	for ($i=0;$i<count($liste_col_cles);$i++){ 
		$nom_col = $liste_col_cles[$i];
		$tmp = "lbl_".$nom_col;
		global $$nom_col;
		global $$tmp;
		$intit_col = $$tmp;
		$mess_tmp .= "'$intit_col', ";
		$select .= $nom_col.", "; 
		$where .= $nom_col." = '".$$nom_col."' AND ";
	}
	$mess_tmp = substr($mess_tmp,0,-2);
	$select = substr($select,0,-2);
	$where = substr($where,0,-4);
	$req = $select.$from.$where;
	$res = $connection->Execute("$req");
	if ($res && $res->RecordCount()!=0){
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp<br></span></center>";
	}
}

// Fonction de vrification pour la saisie des champs obligatoires.
function verifChampsOblig($liste_chp){
	global $connection;
	global $bool_ctrl;
	global $mess_ctrl;
	global $la;
	global $action;
	$mess_tmp = labelLang("erreur_saisie_oblig","message_interface",$la);
	foreach ($liste_chp as $nom_chp=>$val){
		if ( !(($nom_chp=="mdp" && $action=="modifier") || ($nom_chp=="conf_mdp" && $action=="modifier"))){
			global $$nom_chp;
			$tmp = "lbl_".$nom_chp;
			global $$tmp;
			$lbl_chp = $$tmp;
			$oblig = explode("&",$val);
			
			if ($$nom_chp=="" && ($oblig[0]=="O"||$oblig[0]=="o")){
				$bool_ctrl = false;
				$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp'<br></span></center>";
			}
		}
	}
}

// Testes si la valeur saisie est bien un entier.
function testEnt($nom_chp)
{
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp = labelLang("erreur_saisie_entier","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	if ( (string)(int)$$nom_chp != (string)$$nom_chp && $$nom_chp!="" )
	{
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp'<br></span></center>";
	}
}

// Testes si la valeur saisie est bien un flottant.
function testFlo($nom_chp){
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp = labelLang("erreur_saisie_flottant","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	if ( !is_numeric($$nom_chp) && $$nom_chp!="" ){
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp'<br></span></center>";
	}
}

// Contrle du format d'un email.
function testEmail($nom_chp,$long_max){
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp = labelLang("erreur_saisie_email","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	if ( !ereg("^[a-zA-Z0-9]+[a-zA-Z0-9_\.\-]+@[a-zA-Z0-9]{2,}[a-zA-Z0-9_\.\-]*\.[a-zA-Z]{2,3}$",$$nom_chp)
	 && $$nom_chp!="" ){
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp'<br></span></center>";
	}else { longMax($nom_chp,$long_max); }
}
//test format d'une url'
function testUrl($nom_chp,$long_max){
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp = labelLang("erreur_saisie_url","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	if (!ereg("^[h][t][t][p][:][/][/][a-z0-9][-_a-z0-9]*([.][-_a-z0-9]+)?([.][a-z]{2,4}){1,2}",$$nom_chp) && $$nom_chp!="" ){
				
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp'<br></span></center>";
	}else{ longMax($nom_chp,$long_max); }
}

// Contrle de la longueur max d'un champ de saisie libre.
function longMax($nom_chp,$long_max){
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp = labelLang("erreur_saisie_longueurMax","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	if ( strLen($$nom_chp)>$long_max && $$nom_chp!="" ){
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp' ($long_max)<br></span></center>";
	}
}

// Contrle de la longueur min d'un champ de saisie libre.
function longMin($nom_chp,$long_min){
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp = labelLang("erreur_saisie_longueurMin","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	if ( strLen($$nom_chp)<$long_min && $$nom_chp!="" )
	{
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp '$lbl_chp' ($long_min)<br></span></center>";
	}
}

// Contrle de l'intervalle de longueur d'un champ de saisie libre.
function intervLong($nom_chp,$long_max,$long_min)
{
	longMax($nom_chp,$long_max);
	longMin($nom_chp,$long_min);
}

// Contrle du format de la date saisie.
function verifDate($nom_chp)
{
	global $bool_ctrl;
	global $mess_ctrl;
	global $$nom_chp;
	global $la;
	$mess_tmp1 = labelLang("erreur_saisie_dateValide","message_interface",$la);
	$mess_tmp2 = labelLang("erreur_saisie_formatDate","message_interface",$la);
	$tmp = "lbl_".$nom_chp;
	global $$tmp;
	$lbl_chp = $$tmp;
	$jour = substr($$nom_chp,0,2);
	$mois = substr($$nom_chp,3,2);
	$annee = substr($$nom_chp,6,4);
	if ( (!checkdate($mois,$jour,$annee) || !is_numeric($jour) || !is_numeric($mois) || !is_numeric($annee)) && $$nom_chp!="" ){
		$bool_ctrl = false;
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp1 '$lbl_chp'<br></span></center>";
	
	//}elseif( !ereg("^[0-9]{2}-[0-9]{2}-[0-9]{4}$",$$nom_chp) && $$nom_chp!="" ){
	}elseif( !ereg("^[0-9]{4}-[0-9]{2}-[0-9]{2}$",$$nom_chp) && $$nom_chp!="" ){
	
		$bool_ctrl = false;
	
		$mess_ctrl .= "<center><span class=mess_erreur_saisie>$mess_tmp2 '$lbl_chp'<br></span></center>";
	}
}

?>
