--
-- PostgreSQL database dump
--

SET client_encoding = 'LATIN1';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: 
--

CREATE PROCEDURAL LANGUAGE plpgsql;


SET search_path = public, pg_catalog;

--
-- Name: plpgsql_call_handler(); Type: FUNCTION; Schema: public; Owner: postgres
--

CREATE FUNCTION plpgsql_call_handler() RETURNS language_handler
    AS '$libdir/plpgsql', 'plpgsql_call_handler'
    LANGUAGE c;


ALTER FUNCTION public.plpgsql_call_handler() OWNER TO postgres;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: a_pour_parent; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE a_pour_parent (
    code_observatoire character varying(6) NOT NULL,
    fils_sheet_id integer NOT NULL,
    pere_sheet_id integer NOT NULL
);


ALTER TABLE public.a_pour_parent OWNER TO postgres;

--
-- Name: archive_zip; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE archive_zip (
    code_observatoire character varying(6) NOT NULL,
    mtd_sheet_id integer NOT NULL,
    nom_archive character varying(100) NOT NULL,
    taille character varying(30),
    date_maj date,
    heure_maj character varying(30),
    etat_telecharg character varying(6)
);


ALTER TABLE public.archive_zip OWNER TO postgres;

--
-- Name: code_list; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE code_list (
    list_short_name character varying(25) NOT NULL,
    list_name character varying(50) NOT NULL,
    is_stand character varying(5) NOT NULL
);


ALTER TABLE public.code_list OWNER TO postgres;

--
-- Name: contact_catalogue; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE contact_catalogue (
    id_orga integer NOT NULL,
    nom_orga character varying(200) NOT NULL,
    "role" character varying(50),
    adress_postale character varying(200),
    code_postal character varying(20),
    ville character varying(50),
    pays character varying(50),
    email character varying(100),
    url_orga character varying(200),
    url_catalog character varying(200)
);


ALTER TABLE public.contact_catalogue OWNER TO postgres;

--
-- Name: contacts; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE contacts (
    nom character varying(50) NOT NULL,
    organisation character varying(50),
    phone character varying(20),
    address character varying(250),
    postal_code character varying(50),
    city character varying(50),
    country character varying(50),
    email character varying(50),
    url character varying(250),
    "position" character varying(250),
    prenom character varying(250)
);


ALTER TABLE public.contacts OWNER TO postgres;

--
-- Name: elmnt_code_list; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE elmnt_code_list (
    elmnt_id character varying(40) NOT NULL,
    list_short_name character varying(25) NOT NULL,
    elmnt_name character varying(50) NOT NULL,
    elmnt_code character varying(10) NOT NULL,
    is_stand character varying(5) NOT NULL
);


ALTER TABLE public.elmnt_code_list OWNER TO postgres;

--
-- Name: elmnt_gabarit; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE elmnt_gabarit (
    gabarit_name character varying(50) NOT NULL,
    elmnt_mtd_id character varying(50) NOT NULL,
    mandt_code_gab character varying(5) NOT NULL,
    niv_saisie integer,
    max_occ_gab character varying(3) NOT NULL,
    default_val character varying(100),
    num_elmnt_gab character varying(250),
    visibilite integer,
    consult integer,
    visu_consult integer,
    contact character varying(1),
    style character varying(5)
);


ALTER TABLE public.elmnt_gabarit OWNER TO postgres;

--
-- Name: elmnt_liste_interface; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE elmnt_liste_interface (
    elmnt_interf character varying(50) NOT NULL,
    nom_liste character varying(50) NOT NULL,
    code_elmnt character varying(50) NOT NULL
);


ALTER TABLE public.elmnt_liste_interface OWNER TO postgres;

--
-- Name: elmnt_mtd; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE elmnt_mtd (
    elmnt_mtd_id character varying(50) NOT NULL,
    elmnt_name character varying(50) NOT NULL,
    elmnt_short_name character varying(20) NOT NULL,
    stan_name character varying(25) NOT NULL,
    list_short_name character varying(50),
    data_type_code character varying(10) NOT NULL,
    mandt_code character varying(5) NOT NULL,
    max_occ character varying(3) NOT NULL,
    is_core character varying(5),
    is_stand character varying(5)
);


ALTER TABLE public.elmnt_mtd OWNER TO postgres;

--
-- Name: elmnt_thesaurus; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE elmnt_thesaurus (
    elmnt_thes_id character varying(100) NOT NULL,
    id_thesaurus character varying(20) NOT NULL,
    is_root character varying(5)
);


ALTER TABLE public.elmnt_thesaurus OWNER TO postgres;

--
-- Name: est_contenu; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE est_contenu (
    elmnt_fils_id character varying(50) NOT NULL,
    elmnt_pere_id character varying(50) NOT NULL,
    gabarit_name character varying(50) NOT NULL,
    ordre integer NOT NULL
);


ALTER TABLE public.est_contenu OWNER TO postgres;

--
-- Name: est_inclus; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE est_inclus (
    elmnt_fils_id character varying(50) NOT NULL,
    elmnt_pere_id character varying(50) NOT NULL,
    ordre integer
);


ALTER TABLE public.est_inclus OWNER TO postgres;

--
-- Name: fichier_image; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_image (
    mtd_sheet_id integer NOT NULL,
    code_observatoire character varying(6) NOT NULL,
    nom_fichier character varying(100),
    "type" character varying(5),
    taille character varying(30),
    date_image character varying(10),
    description character varying(50)
);


ALTER TABLE public.fichier_image OWNER TO postgres;

--
-- Name: fichier_ressource; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_ressource (
    code_observatoire character varying(6) NOT NULL,
    mtd_sheet_id integer NOT NULL,
    id_fichier integer NOT NULL,
    nom_fichier character varying(100) NOT NULL,
    "type" character varying(3),
    taille character varying(30)
);


ALTER TABLE public.fichier_ressource OWNER TO postgres;

--
-- Name: field_control; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE field_control (
    field_id integer NOT NULL,
    ordre_control integer NOT NULL,
    nom_control character varying(30) NOT NULL,
    event_js character varying(30) NOT NULL
);


ALTER TABLE public.field_control OWNER TO postgres;

--
-- Name: field_elmnt; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE field_elmnt (
    field_id integer NOT NULL,
    gabarit_name character varying(50) NOT NULL,
    elmnt_mtd_id character varying(50) NOT NULL,
    field_type character varying(10) NOT NULL,
    hor_size_text integer,
    vert_size_text integer
);


ALTER TABLE public.field_elmnt OWNER TO postgres;

--
-- Name: gabarit_mtd; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE gabarit_mtd (
    gabarit_name character varying(50) NOT NULL,
    gabarit_date date NOT NULL,
    predef_date character varying(10)
);


ALTER TABLE public.gabarit_mtd OWNER TO postgres;

--
-- Name: gabarit_parent; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE gabarit_parent (
    fils_gabarit_name character varying(50) NOT NULL,
    pere_gabarit_name character varying(50) NOT NULL
);


ALTER TABLE public.gabarit_parent OWNER TO postgres;

--
-- Name: import_form; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE import_form (
    code_observatoire character varying(6) NOT NULL,
    mtd_sheet_id integer NOT NULL,
    source_import character varying(25) NOT NULL,
    fichier_xml character varying(100) NOT NULL,
    import_date character varying(10) NOT NULL
);


ALTER TABLE public.import_form OWNER TO postgres;

--
-- Name: index_search; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE index_search (
    sheet_id integer NOT NULL,
    code_observatoire character varying(100) NOT NULL,
    id_orga integer NOT NULL,
    titre_ress character varying(200) NOT NULL,
    resume character varying(500),
    auteur character varying(500),
    gabarit_name character varying(50),
    begin_date date,
    end_date date,
    private character varying(5),
    titre_ress_2 character varying(200),
    titre_fiche character varying(80),
    date_ress character varying(10),
    date date
);


ALTER TABLE public.index_search OWNER TO postgres;

--
-- Name: jeu_val_predef; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE jeu_val_predef (
    param_predef_id integer NOT NULL,
    "login" character varying(20) NOT NULL,
    jeu_val_date_maj character varying(10),
    jeu_val_name character varying(50),
    gabarit_name character varying(50),
    param_predef_name character varying(50),
    jeu_val_default_m character varying(5),
    jeu_val_default_r character varying(5),
    jeu_val_default_d character varying(5)
);


ALTER TABLE public.jeu_val_predef OWNER TO postgres;

--
-- Name: keywords; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE keywords (
    libellemot character varying(250) NOT NULL,
    categoriemot character varying(250),
    user_key character varying(20) NOT NULL
);


ALTER TABLE public.keywords OWNER TO postgres;

--
-- Name: label; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE label (
    id_foreign_table character varying(100) NOT NULL,
    table_name character varying(50) NOT NULL,
    iso_lang_code character varying(3) NOT NULL,
    defn character varying(500),
    type_label character varying(20) NOT NULL,
    label character varying(500)
);


ALTER TABLE public.label OWNER TO postgres;

--
-- Name: label_stand; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE label_stand (
    id_foreign_table character varying(100) NOT NULL,
    table_name character varying(50) NOT NULL,
    iso_lang_code character varying(3) NOT NULL,
    label character varying(250) NOT NULL,
    defn character varying(500),
    type_label character varying(20) NOT NULL
);


ALTER TABLE public.label_stand OWNER TO postgres;

--
-- Name: langue; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE langue (
    iso_lang_code character varying(3) NOT NULL,
    langue character varying(10) NOT NULL,
    char_set_code character varying(10) NOT NULL
);


ALTER TABLE public.langue OWNER TO postgres;

--
-- Name: liste_interface; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE liste_interface (
    nom_liste character varying(50) NOT NULL
);


ALTER TABLE public.liste_interface OWNER TO postgres;

--
-- Name: map_z3950_mdweb; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE map_z3950_mdweb (
    num_attrib_z3950 integer NOT NULL,
    champ_mdweb character varying(200) NOT NULL,
    table_mdweb character varying NOT NULL
);


ALTER TABLE public.map_z3950_mdweb OWNER TO postgres;

--
-- Name: md_og; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE md_og (
    id_geom integer NOT NULL,
    nom character varying(100) NOT NULL,
    sheet_id integer NOT NULL,
    code_observatoire character varying(100) NOT NULL,
    n real,
    w real,
    e real,
    s real
);


ALTER TABLE public.md_og OWNER TO postgres;

--
-- Name: message_interface; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE message_interface (
    nom_message character varying(100) NOT NULL
);


ALTER TABLE public.message_interface OWNER TO postgres;

--
-- Name: mots_cles; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE mots_cles (
    sheet_id integer NOT NULL,
    code_observatoire character varying(100) NOT NULL,
    libelle character varying(200) NOT NULL,
    nom_thesaurus character varying(200) NOT NULL
);


ALTER TABLE public.mots_cles OWNER TO postgres;

--
-- Name: mtd_form; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE mtd_form (
    mtd_sheet_id integer NOT NULL,
    code_observatoire character varying(6) NOT NULL,
    login_sais character varying(20) NOT NULL,
    login_val character varying(20),
    gabarit_name character varying(50) NOT NULL,
    mtd_nivacces integer,
    update_date character varying(10),
    predef_date character varying(10),
    contact_m_date character varying(10),
    contact_m_name character varying(50),
    titre_fiche character varying(80),
    predef_name character varying(50),
    contact_r_name character varying(50),
    contact_r_date character varying(10),
    contact_d_name character varying(50),
    contact_d_date character varying(10)
);


ALTER TABLE public.mtd_form OWNER TO postgres;

--
-- Name: mtd_value; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE mtd_value (
    mtd_sheet_id integer NOT NULL,
    code_observatoire character varying(6) NOT NULL,
    gabarit_name character varying(50) NOT NULL,
    elmnt_mtd_id character varying(50) NOT NULL,
    num_elmnt character varying(250) NOT NULL,
    mtd_value character varying(500) NOT NULL
);


ALTER TABLE public.mtd_value OWNER TO postgres;

--
-- Name: niv_form; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE niv_form (
    mtd_sheet_id integer NOT NULL,
    code_observatoire character varying(6) NOT NULL,
    niv_saisie integer NOT NULL,
    saisie_complete character varying(5) NOT NULL,
    est_validee character varying(5) NOT NULL,
    date_validation character varying(10),
    default_niv_saisie integer
);


ALTER TABLE public.niv_form OWNER TO postgres;

--
-- Name: observatoire; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE observatoire (
    code_observatoire character varying(6) NOT NULL,
    nom_observatoire character varying(50) NOT NULL,
    pays character varying(50)
);


ALTER TABLE public.observatoire OWNER TO postgres;

--
-- Name: param_control; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE param_control (
    field_id integer NOT NULL,
    ordre_control integer NOT NULL,
    ordre_param integer NOT NULL,
    val_param character varying(50) NOT NULL
);


ALTER TABLE public.param_control OWNER TO postgres;

--
-- Name: param_mdweb; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE param_mdweb (
    version character varying(10) NOT NULL,
    date_version character varying(10) NOT NULL,
    polit_publi integer NOT NULL
);


ALTER TABLE public.param_mdweb OWNER TO postgres;

--
-- Name: standard; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE standard (
    stan_name character varying(25) NOT NULL,
    stan_desc character varying(100) NOT NULL,
    stan_vers character varying(20)
);


ALTER TABLE public.standard OWNER TO postgres;

--
-- Name: struct_thesaurus; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE struct_thesaurus (
    elmnt_pere_id character varying(100) NOT NULL,
    elmnt_fils_id character varying(100) NOT NULL,
    id_thesaurus character varying(20) NOT NULL
);


ALTER TABLE public.struct_thesaurus OWNER TO postgres;

--
-- Name: thesaurus; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE thesaurus (
    id_thesaurus character varying(20) NOT NULL,
    organisme character varying(50),
    date_version date,
    description character varying(250)
);


ALTER TABLE public.thesaurus OWNER TO postgres;

--
-- Name: user_desc; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE user_desc (
    "login" character varying(20) NOT NULL,
    iso_lang_code character varying(3) NOT NULL,
    nom character varying(50) NOT NULL,
    prenom character varying(50),
    email character varying(50),
    mdp character varying(40),
    nivacces integer NOT NULL,
    coulpref character varying(10),
    code_observatoire character varying(6),
    organisation character varying(50),
    phone character varying(20),
    address character varying(250),
    postal_code character varying(50),
    city character varying(50),
    url character varying(250),
    title character varying(10),
    "position" character varying(250),
    countrycd character varying(10)
);


ALTER TABLE public.user_desc OWNER TO postgres;

--
-- Name: utilise_thesaurus; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE utilise_thesaurus (
    elmnt_mtd_id character varying(50) NOT NULL,
    id_thesaurus character varying(20) NOT NULL
);


ALTER TABLE public.utilise_thesaurus OWNER TO postgres;

--
-- Name: valeur_predefinie; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE valeur_predefinie (
    val_predef_id integer NOT NULL,
    param_predef_id integer NOT NULL,
    gabarit_name character varying(50) NOT NULL,
    elmnt_mtd_id character varying(50) NOT NULL,
    val_predef_value character varying(500),
    val_predef_name character varying(50),
    num_elmnt_predef character varying(250),
    visibilite integer,
    contact character varying(1)
);


