<?php
$bbox = input_get_bbox();
$viewboxColl = input_get_viewboxColl();
$srid = input_get_srid();
$layers = input_get_layers();
$width = input_get_width();
$height = input_get_height();
$transparent = input_get_transparent();
$bgcolor = input_get_bgcolor(); 
$version = input_get_version();   // only for input check purpose
$format = input_get_format();   // only for input check purpose
$styles = input_get_styles();   // not yet implemented
$viewbox = bbox_to_viewbox($viewboxColl);

$ratio = bbox_ratio($bbox, $width, $height);
$svg_paths = layer_svg_path($layers, $bbox, $srid, $ratio);
header("Content-type: image/svg+xml");
if(WMS_USE_ZLIB) ini_set('zlib.output_compression', 1);
print("<?xml version='1.0' encoding='utf-8' standalone='no'?>\n");
print('<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 20010904//EN" 
    "http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd">'."\n");
printf("<svg width='%s' height='%s' viewBox='%s'>\n", 
    $width, $height, implode(' ', $viewbox));
if(!$transparent){
	printf("\t<rect x='%s' y='%s' width='%s' height='%s' fill='%s' />\n",
        $viewbox["xmin"], $viewbox["ymin"],
        $viewbox["width"],$viewbox["height"],
        $bgcolor);
}
/*********************** A ARRANGER ****************************/
foreach($svg_paths as $id => $layer_path){
    printf("\t<g %s >\n", style_get_svg(style_layer_default($layers[0])));//$layer[0] because there is only one geom coll table.
    if($layer_path['path'] == 1){
        
        for($i=0 , $end=count($layer_path)-1 ; $i < $end ; $i++){
            
            if(!empty($layer_path[$i]['assvg'])){
	  			
	  			printf("\t\t<path id=\"metadata\" name='%s' d='%s' onmouseover=\"overGeom('%s')\" onmouseout=\"outGeom()\" onclick=\"displayMetadata('%s')\"/>\n", addslashes(utf8_encode($layer_path[$i]['nom'])), $layer_path[$i]['assvg'], addslashes(utf8_encode($layer_path[$i]['nom'])), metadata_search($layer_path[$i]['id_geom'],$layers[0]));
	    	}
	    }
	}
	else{
		for($i=0 , $end=count($layer_path)-2 ; $i < $end ; $i++){
        	printf("\t\t<circle id=\"metadata\" name='%s' %s r='%s' onmouseover=\"overGeom('%s')\" onmouseout=\"outGeom()\" onclick=\"displayMetadata('%s')\"/>\n", addslashes(utf8_encode($layer_path[$i]['nom'])), $layer_path[$i]['assvg'], $layer_path['rayon'], addslashes(utf8_encode($layer_path[$i]['nom'])), metadata_search($layer_path[$i]['id_geom'],$layers[0]));
		}
	}
	print("\t</g>\n");
}
print('</svg>');
?>