<?php

/**
 * Generate xml GetCapabilities request answer
 *
 * @licence     MIT licence
 * @author      Olivier Courtin <ol@cartoweb.org>
 * @version     $Id: generate_capabilities.php,v 1.3 2004/11/11 18:28:46 ol Exp $
 */

//require('/www/MDweb_coord/sigseb/wms_server/config/wms.php');
//require('/www/MDweb_coord/sigseb/wms_server/wms_lib.php');

require("/wamp/www/MDweb/sigseb/wms_server/config/wms.php");
require("/wamp/www/MDweb/sigseb/wms_server/wms_lib.php");


// perf not really the matter here
// still the result xml is cached...


// _get_capabilities_crs($layer_name) {{{
function _get_capabilities_crs($layer_name)
{
    $sql = "
        SELECT srs.auth_name, srs.srid
        FROM geometry_columns AS gc, spatial_ref_sys AS srs
        WHERE f_table_name='$layer_name'
        AND gc.srid=srs.srid
        ";

    return implode(':', db_line($sql));
}
// }}}


// _get_capabilities_geobbox($layer_name) {{{
function _get_capabilities_geobbox($layer_name)
{
    extract(layer_get_info($layer_name));
    $latlon = proj_bbox2latlon(layer_get_bbox($layer_name), $srid);

    return sprintf('
        <EX_GeographicBoundingBox>
            <westBoundLongitude>%s</westBoundLongitude>
            <eastBoundLongitude>%s</eastBoundLongitude>
            <southBoundLatitude>%s</southBoundLatitude>
            <northBoundLatitude>%s</northBoundLatitude>
        </EX_GeographicBoundingBox>
        ', $latlon[0], $latlon[2], $latlon[1], $latlon[3] );
}
// }}}


// _get_capabilities_bbox($layer_name) {{{
function _get_capabilities_bbox($layer_name)
{
    $bbox = layer_get_bbox($layer_name);
    $crs = _get_capabilities_crs($layer_name);

    return sprintf(
        '<BoundingBox CRS="%s" minx="%s" miny="%s" maxx="%s" maxy="%s" />',
            $crs, $bbox[0], $bbox[1], $bbox[2], $bbox[3] );
}
// }}}


// get_capabilities_layers() {{{
function get_capabilities_layers()
{
    //include('/www/MDweb_coord/sigseb/wms_server/config/layers.php');
   	include("/wamp/www/MDweb/sigseb/wms_server/config/layers.php");

    $result = '';
    foreach($layers as $name => $layer)
    {
        $result .= sprintf("
            <Layer>
             <Name>%s</Name>
             <Title>%s</Title>
             <CRS>%s</CRS>
             %s 
             %s
            </Layer>
            ",
            $name, utf8_encode($layer["title"]),
            _get_capabilities_crs($name),
            _get_capabilities_geobbox($name),
            _get_capabilities_bbox($name)
            );   
    }

    return $result;
}
// }}}
print("<?xml version='1.0' encoding='utf-8' ?>");
print("\n");
require("/wamp/www/MDweb/sigseb/wms_server/config/capabilities.php");
//require('/www/MDweb_coord/sigseb/wms_server/config/capabilities.php');
?>
