<?php

/**
 * Tiny WMS Server
 *
 * @licence     MIT licence
 * @author      Olivier Courtin <ol@cartoweb.org>
 * @version     $Id: wms.php,v 1.3 2004/11/12 03:28:58 ol Exp $
 */


// _error_handler($errno, $errstr, $filename, $linenum) {{{
function _error_handler($errno, $errstr, $filename, $linenum){

    // for Production purpose
    $error_msg = $errstr; 
    if($errno == E_USER_ERROR)
        $error_msg = "ServerInternalError";

    // for Debug purpose
    $error_msg = sprintf("[%s]\t%s\tin %s,\tline %s.\n", 
    $errno, $errstr, $filename, $linenum);

    printf('<ServiceExceptionReport version="1.3.0" 
    xmlns="http://www.opengis.net/ogc"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.opengis.net/ogc
    http://schemas.opengis.net/wms/1.3.0/exceptions_1_3_0.xsd">
        <ServiceException>%s</ServiceException>
</ServiceExceptionReport>', $error_msg);

    exit(FALSE);
}
// }}}

error_reporting(E_ALL);
set_error_handler('_error_handler');

//require_once "../../config/config.inc.php";
require('config/wms.php');
require('wms_lib.php');




// input sanity check
if(empty($_GET['SERVICE']) 
    || $_GET['SERVICE'] != 'WMS')
    user_error('OperationNotSupported');

if(empty($_GET['REQUEST']))
    user_error('OperationNotSupported');


// play with right WMS Service
switch($_GET['REQUEST']){

case 'GetMap':
    include 'get_map.php';
    break;

case 'GetCapabilities':
case 'capabilities': 
    readfile('get_capabilities.xml', true);
    break;

// not an official WMS Service
case 'GetLayer':
    include 'get_layer.php';
    break;

// still not an official WMS Service
case 'GetLatLonBbox':
    include 'get_latlonbbox.php';
    break;

// still not an official WMS Service
case 'GetSelection':
    
    require 'get_selection.php';
    break;
default:
    user_error('OperationNotSupported');
}


?>
