<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="no"/>

<xsl:template match="/">
  
  <HTML>
  <HEAD>

  </HEAD>
  <BODY BGCOLOR="#FFFFFF" ONCONTEXTMENU="return false">
  <FONT COLOR="00008B" SIZE="2" FACE="Verdana">

    <!-- Informations sur la représentation spatiale -->
    <xsl:apply-templates select="metadata/spatRepInfo"/>

    <!-- Informations sur le système de référence -->
    <xsl:apply-templates select="metadata/refSysInfo"/>
    

  </BODY>
  </HTML>
</xsl:template>
 

-------- 


<xsl:template match="metadata/dataIdInfo">
	<xsl:if test="roseltTopic">
      		<xsl:for-each select="roseltTopic">
           			<xsl:for-each select="RosTopicCd">
					          <xsl:choose>
					            <xsl:when test="context()[@value = '001']">climat</xsl:when>
					            <xsl:when test="context()[@value = '002']">droit foncier</xsl:when>
					            <xsl:when test="context()[@value = '003']">eau</xsl:when>
					            <xsl:when test="context()[@value = '004']">faune</xsl:when>
					            <xsl:when test="context()[@value = '005']">flore</xsl:when>
					            <xsl:when test="context()[@value = '006']">population humaine</xsl:when>
					            <xsl:when test="context()[@value = '007']">sol</xsl:when>
					            <xsl:when test="context()[@value = '008']">structure du paysage</xsl:when>
					            <xsl:when test="context()[@value = '009']">usages, pratiques d'exploitation</xsl:when>
					            <xsl:when test="context()[@value = '010']">v&#233;g&#233;tation</xsl:when>
					            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
					   		</xsl:choose>
        	        <xsl:if test="context()[not(end())]">, </xsl:if>
       	      	</xsl:for-each>
       </xsl:for-each>
	</xsl:if>
    <xsl:if test="tpCat">
      <xsl:for-each select="tpCat">
        <xsl:for-each select="TopicCatCd">
          <xsl:choose>
            <xsl:when test="context()[@value = '001']">agriculture</xsl:when>
            <xsl:when test="context()[@value = '002']">faune et flore</xsl:when>
            <xsl:when test="context()[@value = '003']">limites politiques et administratives</xsl:when>
            <xsl:when test="context()[@value = '004']">climatologie, météorologie et atmosphère</xsl:when>
            <xsl:when test="context()[@value = '005']">économie</xsl:when>
            <xsl:when test="context()[@value = '006']">altitude</xsl:when>
            <xsl:when test="context()[@value = '007']">Ressources et gestion de l'environnement</xsl:when>
            <xsl:when test="context()[@value = '008']">informations géo-scientifiques</xsl:when>
            <xsl:when test="context()[@value = '009']">santé</xsl:when>
            <xsl:when test="context()[@value = '010']">imagerie, fonds de carte et occupation du sol</xsl:when>
            <xsl:when test="context()[@value = '011']">Infrastructures militaires</xsl:when>
            <xsl:when test="context()[@value = '012']">eaux continentales</xsl:when>
            <xsl:when test="context()[@value = '013']">localisation géographique</xsl:when>
            <xsl:when test="context()[@value = '014']">océans</xsl:when>
            <xsl:when test="context()[@value = '015']">aménagement du territoire et cadastre</xsl:when>
            <xsl:when test="context()[@value = '016']">société</xsl:when>
            <xsl:when test="context()[@value = '017']">structure</xsl:when>
            <xsl:when test="context()[@value = '018']">transport</xsl:when>
            <xsl:when test="context()[@value = '019']">distribution et communication</xsl:when>
            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
	   </xsl:choose>
        <xsl:if test="context()[not(end())]">, </xsl:if>
        </xsl:for-each></FONT>
      </xsl:for-each>
      <xsl:if test="context()[end()]"></xsl:if>
    </xsl:if>

<xsl:if test="idAbs/text()">
    <xsl:for-each select="idAbs">
      <xsl:value-of />
    </xsl:for-each>
</xsl:if>

    <xsl:for-each select="spatRpType">
        <xsl:for-each select="SpatRepTypCd">
          <xsl:choose>
            <xsl:when test="context()[@value = '001']">vecteur</xsl:when>
            <xsl:when test="context()[@value = '002']">raster</xsl:when>
            <xsl:when test="context()[@value = '003']">tableau</xsl:when>
            <xsl:when test="context()[@value = '004']">tin</xsl:when>
            <xsl:when test="context()[@value = '005']">vue 3D</xsl:when>
            <xsl:when test="context()[@value = '006']">vidéo</xsl:when>
            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
	   		</xsl:choose>
        </xsl:for-each></FONT>
       
       <xsl:for-each select="SpatRepTypCd">
          <xsl:choose>
            <xsl:when test="context()[@value = '001']">vector</xsl:when>
            <xsl:when test="context()[@value = '002']">grid</xsl:when>
            <xsl:when test="context()[@value = '003']">text table</xsl:when>
            <xsl:when test="context()[@value = '004']">tin</xsl:when>
            <xsl:when test="context()[@value = '005']">stereo model</xsl:when>
            <xsl:when test="context()[@value = '006']">video</xsl:when>
            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
	   	</xsl:choose>
       </xsl:for-each></FONT>
    </xsl:for-each>

  <xsl:apply-templates select="descKeys"/>
  <xsl:apply-templates select="dataScale"/>
  <xsl:apply-templates select="dataExt"/>
    <xsl:apply-templates select="geoDesc"/>
</xsl:template>


<!-- Keyword Information (B.2.2.2 MD_Keywords - line52)-->
<xsl:template match="descKeys">
     <P><FONT color="#0000AA" size='3'><B>
     <xsl:choose>
     	<xsl:when test="/metadata/langAppli[@value='french']">Mots-cl&#233;s :
    	</xsl:when>
    	<xsl:otherwise>Keywords :
    	</xsl:otherwise>
    </xsl:choose></B></FONT></P>
      
    <xsl:if test="keyword[text()]">
        <P>
        <xsl:for-each select="keyword[text()]">
          <xsl:if test="context()[0]"><FONT color="#0000AA">
        	<xsl:choose>
       			<xsl:when test="/metadata/langAppli[@value='french']">              Mots-cl&#233;s libres :
          		</xsl:when>
          		<xsl:otherwise>Free keywords :
          		</xsl:otherwise>
          		</xsl:choose>
          		</FONT>
          	</xsl:if>
          <FONT color="#000000"><xsl:value-of /></FONT><xsl:if test="context()[not(end())]">, </xsl:if>
        </xsl:for-each>
        </P>
        
      </xsl:if>

      <xsl:if test="keywordThesaurus[text()]">
        <P><FONT color="#0000AA">
        
        <xsl:choose>
       		<xsl:when test="/metadata/langAppli[@value='french']">           Th&#233;saurus :
        	</xsl:when>
        	<xsl:otherwise>Thesaurus
        	</xsl:otherwise>
        </xsl:choose></FONT>
        	<xsl:for-each select="keywordThesaurus">
          
          <FONT color="#000000"><xsl:value-of /></FONT><xsl:if test="context()[not(end())]">, </xsl:if>
        </xsl:for-each>
        </P>
        
      </xsl:if>


   
</xsl:template>

<!-- Browse Graphic Information (B.2.2.1 MD_BrowGraph - line48) -->

<!-- Usage Information (B.2.2.5 MD_Usage - line62) -->

<!-- Resolution Information (B.2.2.4 MD_Resolution - line59) -->
<xsl:template match="(dataScale)">
  
        <P><FONT color="#0000AA" size='3'><B>
        
        <xsl:choose>
       		<xsl:when test="/metadata/langAppli[@value='french']">Résolution spatiale :
        	</xsl:when>
        	<xsl:otherwise>Spatial resolution :
        	</xsl:otherwise>
        </xsl:choose>
        
        
        </B></FONT></P>
    	
      <xsl:apply-templates select="equScale"/>
      
      <xsl:for-each select="scaleDist">
   <!--     <P><FONT color="#0000AA"><B>Distance de référence, au sol:</B></FONT></P>
            value will be shown regardless of the subelement Integer, Real, or Decimal -->
            <xsl:for-each select="value">
              <P><FONT color="#0000AA">
              <xsl:choose>
       		<xsl:when test="/metadata/langAppli[@value='french']">Valeur de la distance au sol du pixel :
              </xsl:when>
              <xsl:otherwise>Precision of spatial data :
              </xsl:otherwise>
              </xsl:choose>
              </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
            </xsl:for-each>

      </xsl:for-each>
      <xsl:apply-templates select="uom"/>

</xsl:template>





-------- 

<!-- SPATIAL REPRESENTATION -->

<!-- Informations sur la représentation spatiale (B.2.6  MD_SpatialRepresentation - line156) -->
<xsl:template match="metadata/spatRepInfo">
  <A><xsl:attribute name="NAME"><xsl:eval>uniqueID(this)</xsl:eval></xsl:attribute><HR/></A>
    
    <xsl:choose>
      <xsl:when test="context()[numDims]">
        <P><FONT color="#0000AA" size="4"><B>
        		<xsl:if test="/metadata/langAppli[@value='french']">Représentation spatiale - Raster :
      			</xsl:if>
      			<xsl:if test="/metadata/langAppli[@value='english']">    			Spatial Representation - Grid :
      			</xsl:if>
        </B></FONT></P>
      
      
      </xsl:when>
      <xsl:when test="context()[topLvl]">
        <P><FONT color="#0000AA" size="4"><B>
        	
       			<xsl:if test="/metadata/langAppli[@value='french']">Représentation spatiale - Vecteur :
       			</xsl:if>
      			
       			<xsl:if test="/metadata/langAppli[@value='english']">Spatial Representation - Vector :
      			</xsl:if>
      			
		</B></FONT></P>
      </xsl:when>
      <xsl:otherwise>
        <P><FONT color="#0000AA" size="4"><B>
        <xsl:if test="/metadata/langAppli[@value='french']">Représentation spatiale :</xsl:if>
        <xsl:if test="/metadata/langAppli[@value='english']">Spatial Representation :</xsl:if>
      	</B></FONT></P>
      </xsl:otherwise>
    </xsl:choose>
  

</xsl:template>



-------- 

<!-- REFERENCE SYSTEM -->

<!-- Informations sur le système de référence (B.2.7 MD_ReferenceSystem - line186) -->
<xsl:template match="metadata/refSysInfo">
  <A><xsl:attribute name="NAME"><xsl:eval>uniqueID(this)</xsl:eval></xsl:attribute><HR/></A>
  <xsl:if expr="(this.selectNodes('/metadata/refSysInfo').length >= 1)">
      <P><FONT color="#0000AA" size="4"><B>
      <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Informations sur le système de référence :     
	        </xsl:when>
	        <xsl:otherwise>Reference System Information :
	        </xsl:otherwise>
	        </xsl:choose>

      
      </B></FONT></P>
  </xsl:if>
  
  
      <xsl:apply-templates select="refSysID"/>

<!--      <xsl:apply-templates select="MdCoRefSys"/> -->

	<!-- no support in the DIS DTD for RS_ReferenceSystem information and TMRefSys, SIRefSys, SCRefSys -->
  <A HREF="#Top">
  <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Retour au début
	        </xsl:when>
	        <xsl:otherwise>Top
	        </xsl:otherwise>
	        </xsl:choose>

 </A>
</xsl:template>


<!-- DISTRIBUTION INFORMATION -->

<!-- Distribution Information (B.2.10 MD_Distribution - line270) -->
<xsl:template match="metadata/distInfo">
  <A><xsl:attribute name="NAME"><xsl:eval>uniqueID(this)</xsl:eval></xsl:attribute><HR/></A>
  <P><FONT color="#0000AA" size="4"><B>
    <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Informations sur la distribution de la ressource :	        
	        </xsl:when>
	        <xsl:otherwise>Distribution Information :
	        </xsl:otherwise>
	        </xsl:choose>
  

  
  </B></FONT></P>
      <xsl:apply-templates select="distributor"/>

      <xsl:apply-templates select="distFormat"/>

      <xsl:apply-templates select="distTranOps"/>
  <A HREF="#Top">
      <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">
		  Retour au début
	        </xsl:when>
	        <xsl:otherwise>Top
	        </xsl:otherwise>
	        </xsl:choose>
</A>
</xsl:template>



<!-- Format Information (B.2.10.3 MD_Format - line284) -->
<xsl:template match="(dsFormat | distorFormat | distFormat)">
  
        <P><FONT color="#0000AA" size='3'><B>
            <xsl:choose>
      			<xsl:when test="/metadata/langAppli[@value='french']">Format de la ressource :
    			</xsl:when>
    			<xsl:otherwise>Distribution format :
    			</xsl:otherwise>
  			</xsl:choose></B></FONT></P>

    <xsl:for-each select="formatName">
      <P><FONT color="#0000AA">
          <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Nom du format :
    </xsl:when>
    <xsl:otherwise>Format name :
    </xsl:otherwise>
  </xsl:choose>
      
      </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
    </xsl:for-each>
    <xsl:if test="formatVer/text()">
    <xsl:for-each select="formatVer">
      <P><FONT color="#0000AA">
          <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">
Version du format :
    </xsl:when>
    <xsl:otherwise>Format version :
    </xsl:otherwise>
  </xsl:choose>

</FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
    </xsl:for-each>
    </xsl:if>
    <xsl:if test="context()[($any$ formatName | formatVer | formatAmdNum | formatSpec | fileDecmTech)]"></xsl:if>

    
</xsl:template>

<!-- Medium Information (B.2.10.4 MD_Medium - line291) -->
<xsl:template match="(distorTran | distTranOps)">
  <P><FONT color="#0000AA" size='3'><B>
      <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Informations pour le transfert de la ressource :
      </xsl:when>
    <xsl:otherwise>Transfer options :
    </xsl:otherwise>
  </xsl:choose>

  </B></FONT></P>

 
    <xsl:apply-templates select="offLineMed"/>

    <xsl:apply-templates select="onLineSrc"/>



   <xsl:for-each select="transSize">
      <P><xsl:if test="context()[text()]">
                <FONT color="#0000AA">
                <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

                Taille du transfert :
               </xsl:when>
    <xsl:otherwise>Transfer size :
    </xsl:otherwise>
  </xsl:choose> 
                </FONT> <FONT color="#000000"><xsl:value-of/></FONT></xsl:if></P>
    
    </xsl:for-each>
    <xsl:if test="context()[($any$ transSize | unitsODist)]"></xsl:if>


</xsl:template>

<!-- Medium Information (B.2.10.4 MD_Medium - line291) -->
<xsl:template match="offLineMed">
  <P><FONT color="#0000AA"><B>
            <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Informations sur le support de distribution :</xsl:when>
    <xsl:otherwise>Medium of distribution :
    </xsl:otherwise>
  </xsl:choose></B></FONT></P>
    <xsl:for-each select="medName">
      <P><FONT color="#0000AA">
      <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

      Nom du médium :</xsl:when>
    <xsl:otherwise>Medium name :
    </xsl:otherwise>
  </xsl:choose></FONT>
        <FONT color="#000000"><xsl:for-each select="MedNameCd">
         
     
          
          <xsl:choose>
            <xsl:when test="context()[@value = '001']">CD-ROM</xsl:when>
            <xsl:when test="context()[@value = '002']">DVD</xsl:when>
            <xsl:when test="context()[@value = '003']">DVD-ROM</xsl:when>
            <xsl:when test="context()[@value = '004']">disquette 3,5 pouces</xsl:when>
            <xsl:when test="context()[@value = '005']">disquette 5,25 pouces</xsl:when>
            <xsl:when test="context()[@value = '006']">bande 7 pistes</xsl:when>
            <xsl:when test="context()[@value = '007']">bande 9 pistes</xsl:when>
            <xsl:when test="context()[@value = '008']">cartouche 3480</xsl:when>
            <xsl:when test="context()[@value = '009']">cartouche 3490</xsl:when>
            <xsl:when test="context()[@value = '010']">cartouche 3580</xsl:when>
            <xsl:when test="context()[@value = '011']">Bande magn&#233;tique 4 mm</xsl:when>
            <xsl:when test="context()[@value = '012']">Bande magn&#233;tique 8 mm</xsl:when>
            <xsl:when test="context()[@value = '013']">Bande magn&#233;tique 0.25 pouces</xsl:when>
            <xsl:when test="context()[@value = '014']">Bande magn&#233;tique 0.5 pouces</xsl:when>
            <xsl:when test="context()[@value = '015']">En ligne</xsl:when>
            <xsl:when test="context()[@value = '016']">liaison satellite</xsl:when>
            <xsl:when test="context()[@value = '017']">liaison téléphonique</xsl:when>
            <xsl:when test="context()[@value = '018']">copie imprimée</xsl:when>
            <xsl:when test="context()[@value = '019']">aucun</xsl:when>
            
            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
	   	</xsl:choose>
        
        </xsl:for-each></FONT>
        </P>
    </xsl:for-each>
    
    
    <xsl:if test="medVol/text()">
    <xsl:for-each select="medVol">
      <P><FONT color="#0000AA">
                      <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">
      volume du médium :
    
    
</xsl:when>
<xsl:otherwise>
      
      Number of media items :
</xsl:otherwise>
</xsl:choose>
      </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
    </xsl:for-each>
  </xsl:if>
  
  
    <xsl:if test="context()[($any$ medName | medVol)]"></xsl:if>

    <xsl:for-each select="medFormat">
      <P><FONT color="#0000AA">
        <xsl:choose>
      		<xsl:when test="/metadata/langAppli[@value='french']">      Format d&apos;écriture du support :
     		</xsl:when>
     		<xsl:otherwise>       How the medium is written :
    		</xsl:otherwise>
		</xsl:choose>
 
      	</FONT>
        <FONT color="#000000">
        <xsl:for-each select="MedFormCd">
        
  
          
				          <xsl:choose>
				            <xsl:when test="context()[@value = '001']">cpio</xsl:when>
				            <xsl:when test="context()[@value = '002']">tar</xsl:when>
				            <xsl:when test="context()[@value = '003']">système de fichiers high sierra</xsl:when>
				            <xsl:when test="context()[@value = '004']">iso9660 (CD-ROM)</xsl:when>
				            <xsl:when test="context()[@value = '005']">iso9660 Rock Ridge</xsl:when>
				            <xsl:when test="context()[@value = '006']">iso9660 Apple HFS</xsl:when>
				            <xsl:when test="context()[@value = '007']">aucun</xsl:when>
				            
				            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
					   
					   </xsl:choose>
   
       
       <xsl:if test="context()[not(end())]">, </xsl:if>
     	
        </xsl:for-each></FONT>
      </P>
    </xsl:for-each>
    
    <xsl:if test="medDensity/text()">
    <xsl:if test="context()[medDensity]">
      <P><FONT color="#0000AA">
      <xsl:choose>
      		<xsl:when test="/metadata/langAppli[@value='french']">      Densité d&apos;enregistrement :
       		</xsl:when>
      		<xsl:otherwise>Recording density :
      		</xsl:otherwise>
  	  </xsl:choose></FONT>
  
    <xsl:for-each select="medDensity">
     	<FONT color="#000000"><xsl:value-of/></FONT>
     	<xsl:if test="context()[not(end())]">, </xsl:if>
     	
    </xsl:for-each></P></xsl:if>
    </xsl:if>

</xsl:template>




<!-- Citation Information (B.3.2 CI_Citation - line359) -->
<xsl:template match="(idCitation | thesaName | identAuth | srcCitatn | evalProc | 
      conSpec | paraCit | portCatCit | catCitation | asName)">
  
      <P><FONT color="#0000AA" size='3'><B>
                <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Informations de Référence :
    </xsl:when>
    <xsl:otherwise>Citation :
    </xsl:otherwise>
    </xsl:choose>
    </B></FONT></P>

    <xsl:for-each select="resTitle">
      <P><FONT color="#0000AA">
           <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

      Titre :
    </xsl:when>
    <xsl:otherwise>Title :
    </xsl:otherwise>
    </xsl:choose>
      
      </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
    </xsl:for-each>
    <xsl:if test="context()[($any$ resTitle | resAltTitle)]"></xsl:if>

    <xsl:for-each select="presForm">
      <P><FONT color="#0000AA">
        <xsl:choose>
      		<xsl:when test="/metadata/langAppli[@value='french']">     Format :
      			</xsl:when>
			    <xsl:otherwise>Presentation format :
			    </xsl:otherwise>
		</xsl:choose>
    
      </FONT>
        <FONT color="#000000">
        <xsl:for-each select="PresFormCd">
      
          
		          <xsl:choose>
		            <xsl:when test="context()[@value = '001']">document numérique</xsl:when>
		            <xsl:when test="context()[@value = '002']">document imprimé</xsl:when>
		            <xsl:when test="context()[@value = '003']">image numérique</xsl:when>
		            <xsl:when test="context()[@value = '004']">image imprimée</xsl:when>
		            <xsl:when test="context()[@value = '005']">carte numérique</xsl:when>
		            <xsl:when test="context()[@value = '006']">carte imprimée</xsl:when>
		            <xsl:when test="context()[@value = '007']">modèle numérique</xsl:when>
		            <xsl:when test="context()[@value = '008']">modèle imprimé</xsl:when>
		            <xsl:when test="context()[@value = '009']">profil numérique</xsl:when>
		            <xsl:when test="context()[@value = '010']">profil imprimé</xsl:when>
		            <xsl:when test="context()[@value = '011']">table numérique</xsl:when>
		            <xsl:when test="context()[@value = '012']">table imprimée</xsl:when>
		            <xsl:when test="context()[@value = '013']">vidéo numérique</xsl:when>
		            <xsl:when test="context()[@value = '014']">vidéo imprimée</xsl:when>
		            <xsl:when test="context()[@value = '015']">Base de données géographique</xsl:when>
		            <xsl:when test="context()[@value = '016']">Base de données alphanumérique</xsl:when>
		            <xsl:when test="context()[@value = '017']">Couche vecteur</xsl:when>
		            <xsl:when test="context()[@value = '018']">Couche raster</xsl:when>
		            <xsl:otherwise><xsl:value-of select="@value"/></xsl:otherwise>
			      </xsl:choose>
   

     </xsl:for-each></FONT>
        </P>
    </xsl:for-each>
    <xsl:if test="context()[($any$ resEd | resEdDate | presForm)]"></xsl:if>
    <xsl:if test="context()[not (text()) and not(*)]"><BR/></xsl:if>

    
</xsl:template>



<!-- Online Resource Information (B.3.2.4 CI_OnLineResource - line396) -->

<xsl:template match="(cntOnlineRes | onLineSrc | extOnRes)">
  <P><FONT color="#0000AA"><B>
  
  <xsl:choose>
    <xsl:when test="../onLineSrc">
  		
	      	<xsl:if test="/metadata/langAppli[@value='french']">Informations sur la ressource en ligne :
			</xsl:if>
			<xsl:if test="/metadata/langAppli[@value='english']">Online resource :
			</xsl:if>
      
    </xsl:when>
	<xsl:when test="../cntOnlineRes">

	    		<xsl:if test="/metadata/langAppli[@value='french']">Ressources en ligne donnant des informations sur l'organisme :
	        	</xsl:if>
				<xsl:if test="/metadata/langAppli[@value='english']">Online resource :    
				</xsl:if>

	    
	</xsl:when>
	<xsl:otherwise>
	</xsl:otherwise>
</xsl:choose>
	</B></FONT></P>
    
    
    <xsl:if test="orName/text()">
    
    <xsl:for-each select="orName">
      <P><FONT color="#0000AA">
    <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Nom de la ressource : 
        </xsl:when>
		<xsl:otherwise>Ressource's name :
		</xsl:otherwise>
	</xsl:choose>    

</FONT>
<FONT color="#000000"><xsl:value-of/></FONT></P>
    </xsl:for-each>
    </xsl:if>
    
    <xsl:if test="linkage/text()">
    	<xsl:for-each select="linkage">
      	<P><FONT color="#0000AA">
      	<xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Emplacement (URL) :
        </xsl:when>
		<xsl:otherwise>Location (URL) :    
		</xsl:otherwise>
		</xsl:choose>
		</FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
    	</xsl:for-each>
    </xsl:if>
    
	 <xsl:if test="orDesc/@DescCd/text()">

    <xsl:for-each select="orDesc">
     <P><FONT color="#0000AA">
     <xsl:choose>
     <xsl:when test="/metadata/langAppli[@value='french']">Description du service proposé :</xsl:when>
	 <xsl:otherwise> Description :   
	 </xsl:otherwise>
	 </xsl:choose>
	 </FONT>
	 
	
	 <FONT color="#000000">
	<xsl:for-each select="DescCd">
    <xsl:if test="/metadata/langAppli[@value='french']">

        <xsl:choose>
            <xsl:when test="context()[@value= '001']">Serveur cartographique</xsl:when>
            <xsl:when test="context()[@value = '002']">Fichiers téléchargeables</xsl:when>
            <xsl:when test="context()[@value = '003']">Images statiques de cartes</xsl:when>
            <xsl:when test="context()[@value = '004']">Fichiers hors ligne</xsl:when>
            <xsl:when test="context()[@value = '005']">Site</xsl:when>
            <xsl:otherwise><xsl:value-of /></xsl:otherwise>
	   </xsl:choose>
	 
	 </xsl:if>
	<xsl:if test="/metadata/langAppli[@value='english']">    
        
        <xsl:choose>
            <xsl:when test="context()[@value= '001']">geographic server</xsl:when>
            <xsl:when test="context()[@value = '002']">downloadable file</xsl:when>
            <xsl:when test="context()[@value = '003']">static image map</xsl:when>
            <xsl:when test="context()[@value = '004']">off line file</xsl:when>
            <xsl:when test="context()[@value = '005']">web</xsl:when>
            <xsl:otherwise><xsl:value-of /></xsl:otherwise>
	    </xsl:choose>
	
	</xsl:if>
	<xsl:if test="context()[not(end())]">, </xsl:if>
	</xsl:for-each></FONT>
    
        </P>
        
    </xsl:for-each>
  </xsl:if>     
  
</xsl:template>

<!-- Series Information (B.3.2.5 CI_Series - line403) -->

-------- 

<!-- EXTENT INFORMATION -->

<!-- Extent Information (B.3.1 EX_Extent - line334) -->
<xsl:template match="(dataExt | scpExt | srcExt)">
	  <P><FONT color="#0000AA" size='3'><B>
	<xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Informations sur l'extension spatiale et temporelle :
	    </xsl:when>
		<xsl:otherwise>Extent and temporal information :    
		</xsl:otherwise>
	</xsl:choose>
	</B></FONT> </P>
      <xsl:for-each select="geoEle">
         
          	<xsl:apply-templates select="GeoDesc"/>
          
            <xsl:apply-templates select="GeoBndBox"/>
            
        <xsl:if test="context()[not (*)]"><BR/></xsl:if>
      </xsl:for-each>

      <xsl:for-each select="tempEle">
        <xsl:apply-templates select="exTemp"/>
      </xsl:for-each>

      <xsl:apply-templates select="vertEle"/>
</xsl:template>


<!-- Bounding Polygon Information (B.3.1.1 EX_BoundingPolygon - line341) -->

<!-- Bounding Box Information (B.3.1.1 EX_GeographicBoundingBox - line343) -->
<xsl:template match="(geoBox | GeoBndBox)">
	  <P><FONT color="#0000AA"><B>
	             <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Emprise géographique :
	            </xsl:when>
<xsl:otherwise>Resource's bounding rectangle :
 </xsl:otherwise>
 </xsl:choose>
</B></FONT> </P>
    
      
	   		</FONT>
        </P>      
      </xsl:for-each>
      
      <xsl:for-each select="westBL">
        <P><FONT color="#0000AA">
                   <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">
Longitude Ouest :
</xsl:when>
<xsl:otherwise>West longitude
</xsl:otherwise>
</xsl:choose>    
</FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
      </xsl:for-each>
      <xsl:for-each select="eastBL">
        <P><FONT color="#0000AA">
                   <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

        Longitude Est :
        </xsl:when>
<xsl:otherwise>East longitude
</xsl:otherwise>
</xsl:choose>
    </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
      </xsl:for-each>
      <xsl:for-each select="northBL">
        <P><FONT color="#0000AA">
                   <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

        Latitude Nord :
        </xsl:when>
<xsl:otherwise>North latitude
</xsl:otherwise>
</xsl:choose>
    </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
      </xsl:for-each>
      <xsl:for-each select="southBL">
        <P><FONT color="#0000AA">
                   <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

        Latitude Sud :
        </xsl:when>
<xsl:otherwise>South latitude
</xsl:otherwise>
</xsl:choose>
    </FONT> <FONT color="#000000"><xsl:value-of/></FONT></P>
      </xsl:for-each>
  
</xsl:template>

<!-- Geographic Description Information (B.3.1.1 EX_GeographicDescription - line348) -->

<xsl:template match="(geoDesc | GeoDesc)">
      <xsl:for-each select="geoId/identCode">
        <P><FONT color="#0000AA">
        <xsl:choose>
      		<xsl:when test="/metadata/langAppli[@value='french']">Nom de l'observatoire :
        	</xsl:when>
			<xsl:otherwise>Observatory name
			</xsl:otherwise>
		</xsl:choose>
    </FONT>
          
	    	<FONT color="#000000"><xsl:for-each select="ObservCd">
    	    	           

    	    	
    	    	<xsl:choose>
        	    	<xsl:when test="context()[@value= '001']">Dantiandou, Torodi et Tondikandia (Niger)</xsl:when>
            		<xsl:when test="context()[@value = '002']">Keita (Niger)</xsl:when>
            		<xsl:when test="context()[@value = '003']">Cercle de Bourem (Mali)</xsl:when>
            		<xsl:when test="context()[@value = '004']">Niono (Mali)</xsl:when>
            		<xsl:when test="context()[@value = '005']">Boucle du Baoul&#233;(Mali)</xsl:when>
            		<xsl:when test="context()[@value = '006']">El Omayed (Egypte)</xsl:when>
            		<xsl:when test="context()[@value = '007']">Ferlo (S&#233;n&#233;gal)</xsl:when>
            		<xsl:when test="context()[@value = '008']">Haddej Bou Hedma (Tunisie)</xsl:when>
            		<xsl:when test="context()[@value = '009']">Menzel Habib (Tunisie)</xsl:when>
            		<xsl:when test="context()[@value = '010']">Issougui (Maroc)</xsl:when>
            		<xsl:when test="context()[@value = '011']">Oued Mird (Maroc)</xsl:when>
            		<xsl:when test="context()[@value = '012']">Kibwesi Kiboko (Kenya)</xsl:when>
            		<xsl:when test="context()[@value = '013']">Nouackchott (Mauritanie)</xsl:when>
            		<xsl:when test="context()[@value = '014']">Ribeira Seca (Cap vert)</xsl:when>
					<xsl:when test="context()[@value = '015']">Steppes des Hautes Plaines (Alg&#233;rie</xsl:when>
            		<xsl:when test="context()[@value = '016']">Matruh (Egypte)</xsl:when>
					<xsl:when test="context()[@value = '017']">Coordination R&#233;gionale ROSELT</xsl:when>
            		<xsl:otherwise><xsl:value-of />autre</xsl:otherwise>
	   			</xsl:choose>
        	</xsl:for-each></FONT>   
          
          
        </P>      
      </xsl:for-each>
      
</xsl:template>

<!-- Temporal Extent Information (B.3.1.2 EX_TemporalExtent - line350) -->
<xsl:template match="exTemp">
  	  <P><FONT color="#0000AA"><B>
  	             <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Eléments temporel :
  	  </xsl:when>
  	  <xsl:otherwise>Temporal extent of the ressource :
  	  </xsl:otherwise>
  	  </xsl:choose>
  	  </B></FONT> </P>
  
  <xsl:apply-templates select="TM_GeometricPrimitive"/>
</xsl:template>

<!-- temporal extent Information from ISO 19103 as defined is DTD -->

<xsl:template match="TM_GeometricPrimitive">
  <xsl:for-each select="TM_Period">
  <xsl:if test="begin/text()">
  
      <xsl:for-each select="begin">
        <P><FONT color="#0000AA">
                   <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">Date de début :
        </xsl:when>
  	  <xsl:otherwise>Beginning date :
  	  </xsl:otherwise>
  	  </xsl:choose>
        
        </FONT> <FONT color="#000000"><xsl:value-of /></FONT></P>
      </xsl:for-each>
      </xsl:if>
      <xsl:if test="end/text()">
      <xsl:for-each select="end">
        <P><FONT color="#0000AA">
                   <xsl:choose>
      	<xsl:when test="/metadata/langAppli[@value='french']">

        Date de fin :
        </xsl:when>
  	  <xsl:otherwise>Ending date :
  	  </xsl:otherwise>
  	  </xsl:choose>
        
        </FONT> <FONT color="#000000"><xsl:value-of /></FONT></P>
      </xsl:for-each>
      </xsl:if>
  </xsl:for-each>
  
  
</xsl:template>
  </xsl:stylesheet>