<?php 
/**
* Classe pour la cration d'un archive ZIP pouvant contenir des rpertoires et plusieurs fichiers.
* 
* Le code source et les explications  propos de cette classe peuvent tre trouvs  l'adresse :
* {@link http://www.zend.com/zend/spotlight/creating-zip-files3.php}
* Quelques modifications y ont t apportes, en tenant compte des remarques trouves  la mme adresse.
* Deux exemples d'utilisation peuvent tre trouvs en bas de ce fichier.
* 
* @author John Coggeshall
* @copyright Octobre 2001 John Coggeshall
* @copyright Mai 2004 Nicolas Moyroud pour la traduction franaise
*/
class zipfile 
{ 
	/////////////////////////////////////////////////
	// VARIABLES DE LA CLASSE
	/////////////////////////////////////////////////
	/**#@+
	* @access private
	*/
		/**
		* @var array
		*/ 
		var $datasec = array(); 
		
		/**
		* @var array
		*/ 
		var $ctrl_dir = array(); 
		
		/**
		* @var string
		*/ 
		var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00"; 
		
		/**
		* @var int
		*/ 
		var $old_offset = 0; 
	/**#@-*/
	

	/////////////////////////////////////////////////
	// METHODES DE LA CLASSE
	/////////////////////////////////////////////////
	/**
	* Ajout d'un rpertoire dans l'archive ZIP.
	* @param string $name nom du rpertoire  ajouter
	*/
	function add_dir($name) { 
		$name = str_replace("\\", "/", $name); 
		
		$fr = "\x50\x4b\x03\x04"; 
		$fr .= "\x0a\x00"; 
		$fr .= "\x00\x00"; 
		$fr .= "\x00\x00"; 
		$fr .= "\x00\x00\x00\x00"; 
		
		$fr .= pack("V",0); 
		$fr .= pack("V",0); 
		$fr .= pack("V",0); 
		$fr .= pack("v", strlen($name) ); 
		$fr .= pack("v", 0 ); 
		$fr .= $name; 
		$fr .= pack("V", 0); 
		$fr .= pack("V", 0); 
		$fr .= pack("V", 0); 
		
		$this -> datasec[] = $fr;
		//$new_offset = strlen(implode("", $this->datasec)); 
		$new_offset = $this -> old_offset + strlen($fr); 
		
		$cdrec = "\x50\x4b\x01\x02"; 
		$cdrec .="\x00\x00"; 
		$cdrec .="\x0a\x00"; 
		$cdrec .="\x00\x00"; 
		$cdrec .="\x00\x00"; 
		$cdrec .="\x00\x00\x00\x00"; 
		$cdrec .= pack("V",0); 
		$cdrec .= pack("V",0); 
		$cdrec .= pack("V",0); 
		$cdrec .= pack("v", strlen($name) ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("v", 0 ); 
		$ext = "\x00\x00\x10\x00"; 
		$ext = "\xff\xff\xff\xff"; 
		$cdrec .= pack("V", 16 ); 
		$cdrec .= pack("V", $this -> old_offset ); 
		$cdrec .= $name; 
		
		$this -> ctrl_dir[] = $cdrec; 
		$this -> old_offset = $new_offset; 
		return; 
	} 
	
	/**
	* Ajout d'un fichier dans l'archive ZIP.
	* @param string $data chemin complet du fichier source  ajouter (avec le nom du fichier)
	* @param string $name chemin complet du fichier aprs stockage dans l'archive (avec le nom du fichier)
	*/
	function add_file($data, $name) { 
		$fp = fopen($data,"r");
		$data = fread($fp,filesize($data));
		fclose($fp);
		$name = str_replace("\\", "/", $name); 
		$unc_len = strlen($data); 
		$crc = crc32($data); 
		$zdata = gzcompress($data); 
		$zdata = substr ($zdata, 2, -4); 
		$c_len = strlen($zdata); 
		$fr = "\x50\x4b\x03\x04"; 
		$fr .= "\x14\x00"; 
		$fr .= "\x00\x00"; 
		$fr .= "\x08\x00"; 
		$fr .= "\x00\x00\x00\x00"; 
		$fr .= pack("V",$crc); 
		$fr .= pack("V",$c_len); 
		$fr .= pack("V",$unc_len); 
		$fr .= pack("v", strlen($name) ); 
		$fr .= pack("v", 0 ); 
		$fr .= $name; 
		$fr .= $zdata; 
		$fr .= pack("V",$crc); 
		$fr .= pack("V",$c_len); 
		$fr .= pack("V",$unc_len); 
		
		$this -> datasec[] = $fr; 
		//$new_offset = strlen(implode("", $this->datasec)); 
		$new_offset = $this -> old_offset + strlen($fr); 
		
		$cdrec = "\x50\x4b\x01\x02"; 
		$cdrec .="\x00\x00"; 
		$cdrec .="\x14\x00"; 
		$cdrec .="\x00\x00"; 
		$cdrec .="\x08\x00"; 
		$cdrec .="\x00\x00\x00\x00"; 
		$cdrec .= pack("V",$crc); 
		$cdrec .= pack("V",$c_len); 
		$cdrec .= pack("V",$unc_len); 
		$cdrec .= pack("v", strlen($name) ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("v", 0 ); 
		$cdrec .= pack("V", 32 ); 
		$cdrec .= pack("V", $this -> old_offset ); 
		
		$this -> old_offset = $new_offset; 
		
		$cdrec .= $name; 
		$this -> ctrl_dir[] = $cdrec; 
	} 
	
	/**
	* Finalisation de l'archive et renvoi du contenu.
	* @return string
	*/
	function file() { 
		$data = implode("", $this -> datasec); 
		$ctrldir = implode("", $this -> ctrl_dir); 
		
		return 
			$data . 
			$ctrldir . 
			$this -> eof_ctrl_dir . 
			pack("v", sizeof($this -> ctrl_dir)) . 
			pack("v", sizeof($this -> ctrl_dir)) . 
			pack("V", strlen($ctrldir)) . 
			pack("V", strlen($data)) . 
			"\x00\x00"; 
	} 
}

/*
///////////////////////////////////////////////////////
// EXEMPLES D'UTILISATION DE LA CLASSE
///////////////////////////////////////////////////////

$zipTest = new zipfile();
$zipTest->add_dir("test/");
$zipTest->add_file("test.php", "test/test_zippe.php");
$zipTest->add_file("test2.php", "test/test2_zippe.php");

// Renvoyer le fichier ZIP directement au navigateur.
Header("Content-type: application/octet-stream");
Header ("Content-disposition: attachment; filename=zipTest.zip");
echo $zipTest->file();
	
// On peut galement crire le fichier ZIP sur le serveur et fournir un lien vers ce fichier.
$filename = "ressources/test.zip";
$fd = fopen ($filename, "wb");
$out = fwrite ($fd, $zipTest -> file());
fclose ($fd);
	
echo '<a href="ressources/test.zip">Cliquer ici pour tlcharger le nouveau fichier zip.</a>';
*/	

?>