<?php
/*********************************************************************************************************
* Ce fichier gre les formulaires de saisie pour le remplissage des fiches de mtadonnes.
* La premire partie est charge d'envoyer les valeurs saisies par l'utilisateur dans la base de mtadonnes.
* La deuxime partie du script gnre le formulaire de saisie correspondant  la section choisie dans la fentre gauche (script saisie_menu.php) et au gabarit slectionn pour la fiche.
**********************************************************************************************************/

// Insertion du fichier de configuration de l'appli et des fichiers contenant les bibliothques de fonctions.
require_once "../config/config.inc.php";
require_once $chemin_appli."config/fonctions.inc.php";
require_once $chemin_appli."config/erreurs.inc.php";
require_once $chemin_appli."users/inc/fonctions.inc.php";
// Ouverture de la session utilisateur et vrification de sa validit.
session_start($PHPSESSID);
if (!sessionValide($PHPSESSID,$nomUtil)){
	$bad_login=1;
	include $chemin_appli."index.php";	session_destroy();
	exit();
}
require_once $chemin_appli."classes/Synchronisateur.php";
require_once $chemin_appli."classes/GestionnaireGabarit.php";
$gest=new GestionnaireGabarit();
$synchro=new Synchronisateur($gest);
$web_carto_button=false;
// Rcupration du thme de couleur prfr de l'utilisateur.
$theme=coulPref($nomUtil);

// Rcupration de la langue pour le menu (franais ou anglais).
$lang=langMenu($nomUtil);

// Rcupration de la langue choisie par l'utilisateur.
$la=langUtil($nomUtil);
$firstPrint=1;
?>

<html>
<head>
<title></title>
<meta name="Description" content="">
<meta name="Keywords" content="">
<meta name="Author" content="IRD">
<meta name="Generator" content="Dev-PHP 3.00 Alpha 4">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

<?php
//<script language="javascript" src="../keywords/script.js"></script>
require_once $chemin_appli."keywords/script_js.php";

// Insertion de la feuille de style.
echo "<link rel='stylesheet' type='text/css' href='".$url_site.$alias_appli."config/MDweb.css'>";
// Insertion des fonctions Javascripts de contrle de la saisie.
require_once $chemin_appli."config/fonctions_ctrl_js.inc.php";
$rubr_deja_saisie = rubrDejaSaisie($code_observatoire,$mtd_sheet_id_insert,$compt);

// On rcupre un certain nombres de labels dans la base.
$intit_gab = labelLang($gab_name,"gabarit_mtd",$la,"label");
$intit_racine = labelLang($id_racine,"elmnt_mtd",$la,"label_stand");
$intit_obs = labelObserv($code_observatoire);
$lbl_niv_saisie = labelLang("niv_saisie","liste_interface",$la,"label");
$aff_niv_saisie = labelLang("niv_saisie_$niv_saisie","elmnt_liste_interface",$la,"label");
$nom_section = labelLang($id_racine,"elmnt_mtd",$la,"label_stand");
$lbl_niv_complet = labelLang("niv_complet","message_interface",$la,"label");
$lbl_niv_pas_complet = labelLang("niv_pas_complet","message_interface",$la,"label");

//$titre_fiche = stripslashes($titre_fiche);
//$titre_fiche_transm = htmlentities($titre_fiche,ENT_QUOTES);
//recup du titre de la fiche
$req_fiche="SELECT titre_fiche" .
		" FROM mtd_form" .
		" WHERE code_observatoire='$code_observatoire'" .
		" AND mtd_sheet_id='$mtd_sheet_id'";
$res_fiche=$connection->Execute("$req_fiche");
$ligne_fiche=$res_fiche->FetchRow();
$titre_fiche=$ligne_fiche['titre_fiche'];

//recup code iso de l'observatoire
$req_Obs = "SELECT elmnt_code" .
		" FROM elmnt_code_list" .
		" WHERE list_short_name='ObservCd'" .
		" AND elmnt_name='$code_observatoire'";
$res_Obs = $connection->Execute($req_Obs);
$ligne_Obs=$res_Obs->FetchRow();

global $code_iso_observatoire;
$code_iso_observatoire=$ligne_Obs['elmnt_code'];				

$nbkeywords=0;

// Affichage de l'en-tte du formulaire (nom de la fiche, gabarit utilis, observatoire associ, niveau de saisie).
//$code_corps .="<style type='text/css'>body {margin-left: 13px; }</style>";
$code_corps .="</head><body>\n";


$code_corps .="<table width=655 border=0 cellspacing=0 cellpadding=0 bgcolor='#E2E0DD' ><tr><td>\n";
$code_corps .="<table width=100% border=0 cellspacing=0 cellpadding=1 bgcolor='#E2E0DD' >\n";
$code_corps .="<tr><td align=left><font class=titre2_$theme>$titre_fiche</font>";
$code_corps .= "</td>";
/*if ($nom_fichier_image) {
	$code_corps .="<td align=center>";
	$code_corps .="<img width='200' height='133' align='center' src='../images/".$nom_fichier_image."' />";
	$code_corps .="<input type=hidden name=fichier_image value=\"$nom_fichier_image\">\n";
	$code_corps .="</td>";
}
*/
$code_corps .="<td align=right><font class=text_$theme>$intit_gab<br>$intit_obs<br>$lbl_niv_saisie : $aff_niv_saisie</font></td></tr>\n";
$code_corps .="</table>\n";


// *******************************************************************************************************
// *  Bloc de traitement pour l'envoi des valeurs dans la base aprs saisie et soumission du formulaire. *
// *******************************************************************************************************

if ($envoi_valeurs!=""){
	// Mise  jour de la date de dernire modification de la fiche.
	
	
	$date_cour = date("Y-m-d");
	$req = "UPDATE mtd_form" .
			" SET update_date='$date_cour'" .
			" WHERE mtd_sheet_id='$mtd_sheet_id_insert'" .
			" AND code_observatoire='$code_observatoire'";
	$connection->Execute("$req");

	// -------------------------------------------
		// On parcourt les champs transmis par la mthode POST. On rcupre l'identifiant des lments du gabarit qui correspondent
		//  ces champs. Chaque lment est charg en un seul exemplaire dans le tableau $tab_delete (mme si il est saisi avec des
		// valeurs multiples).
		foreach ($HTTP_POST_VARS as $cle=>$val){
			// On n'a pas besoin de traiter les champs particuliers dont le nom commence par nb_ex, compt, envoi_valeurs ou thesaurus
			// (ce sont des champs cachs utiliss pour le fonctionnement du formulaire).
			if ( !ereg("^nb_ex_.*$",$cle) && !ereg("^compt_.*$",$cle) && !ereg("^envoi_valeurs$",$cle)){
				ereg ("^(.*)_[0-9a-zA-Z]+$",$cle,$corresp);
				$elmnt_mtd_id_cour = $corresp[1];
				$tab_delete["$elmnt_mtd_id_cour"]=$elmnt_mtd_id_cour;
			}
		}

		// On utilise le tableau $tab_delete pour supprimer les anciennes valeurs des lments (si elles sont dj prsentes dans la base).
		foreach ($tab_delete as $val){
			// On cherche si cet lment avait dj t saisi au moins avec une valeur.
			// Dans ce cas on supprime de la base toutes les valeurs associe  cet lment.
			$req = "SELECT num_elmnt" .
					" FROM mtd_value" .
					" WHERE mtd_sheet_id='$mtd_sheet_id_insert'" .
					" AND code_observatoire='$code_observatoire'" .
					" AND gabarit_name='$gab_name'" .
					" AND elmnt_mtd_id='$val'";
			$res = $connection->Execute("$req");
			if ($res->RecordCount()>0){
				$req = "DELETE FROM mtd_value" .
						" WHERE mtd_sheet_id='$mtd_sheet_id_insert'" .
						" AND code_observatoire='$code_observatoire'" .
						" AND gabarit_name='$gab_name' AND elmnt_mtd_id='$val'";
				$connection->Execute("$req");
			}
		}

	// -------------------------------------------
	// On insre dans la base les nouvelles valeurs saisies dans les champs du formulaire.
	$keywordWithThesaurus=false;
	foreach ($HTTP_POST_VARS as $cle=>$val){
		// On n'a pas besoin de traiter les champs particuliers dont le nom commence par nb_ex, compt, envoi_valeurs ou thesaurus.
		if (!ereg ("^thesaurus_id_.*$",$cle) && !ereg("^nb_ex_.*$",$cle) && !ereg("^compt_.*$",$cle)
																		 && !ereg("^envoi_valeurs$",$cle)){
			/*if(ereg("^keyword_.*$",$cle) && $val!=""){
				ereg ("^(.*)_([0-9a-zA-Z]+)$",$cle,$corresp);
				$elmnt_mtd_id_cour = $corresp[1];
				$num_elmnt_cour = $corresp[2];
			}*/
			$insertValue=false;
			$pattern_space = "/^[\s\t]+$/";
			
			if(ereg("^thesaurus_.*$",$cle) && $val!=""){	
				
				if (!$keywordWithThesaurus){
					ereg ("^thesaurus_(.*)_([0-9a-zA-Z]+)$",$cle,$corresp);
					$elmnt_mtd_id_cour = $corresp[1];
					$num_elmnt_cour = $corresp[2];
					$insertValue=true;
					
					//CAP VERT
					$req_select="SELECT *" .
							" FROM keywords" .
							" WHERE libellemot='$val'";
					
					$res=$connection->Execute($req_select);
					
					if ($res->RecordCount()==0){
						$req_insert="INSERT INTO keywords(libellemot,user_key) VALUES('$val','$nomUtil')";
						
						$connection->Execute($req_insert);			
					}
					//CAP VERT
				
				}
			}elseif(ereg("^keyword_269_.*$",$cle)){
				if ($val!=""){	
					ereg ("^keyword_269_([0-9a-zA-Z]+)$",$cle,$corresp);
					$elmnt_mtd_id_cour = "keyword_269";
					$num_elmnt_cour = $corresp[1];
					$lbl_elmnt = labelLang("$val","elmnt_thesaurus",$la,"label");
					if ($lbl_elmnt==""){
						$keywordWithThesaurus=false;
						//$insertValue=true;
					}else{
						$keywordWithThesaurus=true;
						$insertValue=true;
					}
				}else{
					$keywordWithThesaurus=false;
				}
			}else{
				if(ereg ("^(.*)_([0-9a-zA-Z]+)$",$cle,$corresp)){
					ereg ("^(.*)_([0-9a-zA-Z]+)$",$cle,$corresp);
					$elmnt_mtd_id_cour = $corresp[1];
					$num_elmnt_cour = $corresp[2];
					$insertValue=true;
				//MODIF ICI
				/*}else{
					$insertValue=false;
					
				}*/
				}
			}
			
			if ($insertValue && $val!="" && !preg_match($pattern_space, $val, $match)){
				
				$req_rub="SELECT data_type_code" .
					" FROM elmnt_mtd" .
					" WHERE elmnt_mtd_id='$elmnt_mtd_id_cour'";
				$res_rub=$connection->Execute($req_rub);
				$ligne_rub=$res_rub->FetchRow();
				if (!($ligne_rub['data_type_code']=="rubrique" && $val==1)){		
					// Si la valeur saisie n'est pas vide, on l'insre dans la base.
					//if ($val!="")
					$req = "INSERT INTO mtd_value" .
						" VALUES ('$mtd_sheet_id_insert'," .
						"'$code_observatoire'," .
						"'$gab_name'," .
						"'$elmnt_mtd_id_cour'," .
						"'$num_elmnt_cour'," .
						"'$val')";
					$connection->Execute("$req");
				}
			}
		}elseif (ereg ("^thesaurus_id_.*$",$cle)){
			ereg ("^.*_([0-9a-zA-Z]+)$",$cle,$corresp);
			$num_elmnt_cour = $corresp[1];
			$num_elmnt_cour=substr_replace($num_elmnt_cour,"",-1);
			$synchro->synchroThesaurus($mtd_sheet_id, $code_observatoire, $gab_name,$val,$num_elmnt_cour,$keywordWithThesaurus);
		}
	}
	
	//insert row table index
	include_once $chemin_appli."classes/GestionnaireGabarit.php";
	$gestGab=new GestionnaireGabarit();
	include_once $chemin_appli."classes/SynchroSearch.php";
	$synchroSearch=new SynchroSearch($connection,$connection_sig,$gestGab);
	$synchroSearch->insertOrUpdateOneSheet($mtd_sheet_id,$code_observatoire);
		
	// -------------------------------------------
	// On renvoie un message pour indiquer le bon fonctionnement de l'insertion ou de la mise  jour des valeurs.
	if ($fonction=="ajouter") {	$mess_tmp = labelLang("mess_ajout_base","message_interface",$la); }
	if ($fonction=="modifier") { $mess_tmp = labelLang("mess_modif_base","message_interface",$la); }
	$code_corps .="<center><span class=mess_confirm_envoi>$mess_tmp</span></center><br>";
	
	// -------------------------------------------
	// Aprs chaque envoi de valeurs dans la base, il faut tester si chacun des 3 niveaux de saisie de la fiche est entirement rempli.
	// Si un niveau est rempli, on passe  "true" la valeur du champ saisie_complete de la table niv_form (pour ce niveau).
	for ($i=0;$i<=2;$i++){
		$bool_preced = true;
		// Pour les niveaux 1 et 2, il faut commencer par rcuprer l'tat du niveau prcdent.
		if ($i>0){
			$niv_preced = $i-1;
			$req_init = "SELECT saisie_complete" .
					" FROM niv_form" .
					" WHERE code_observatoire='$code_observatoire'" .
					" AND mtd_sheet_id='$mtd_sheet_id_insert'" .
					" AND niv_saisie='$niv_preced'";
			$res_init = $connection->Execute("$req_init");
			$ligne_init = $res_init->FetchRow();
			$saisie_complete_preced = $ligne_init["saisie_complete"];
			$bool_preced = ($saisie_complete_preced == "true");
		}
		// Si on est au niveau 0 ou que le niveau prcdent est rempli, on doit tester si le niveau courant
		// est rempli puis mettre  jour son tat.
		if ($bool_preced){
			// La fonction estCompletNiveauSaisie du fichier config/fonctions.inc.php
			// est charge de tester si un niveau est rempli.
			if (estCompletNiveauSaisie("$mtd_sheet_id_insert","$code_observatoire","$gab_name","$i")){
				$saisie_complete = "true";
			}else{
				$saisie_complete = "false";
			}
			$req = "UPDATE niv_form" .
					" SET saisie_complete='$saisie_complete'" .
					" WHERE code_observatoire='$code_observatoire'" .
					" AND mtd_sheet_id='$mtd_sheet_id_insert'" .
					" AND niv_saisie='$i'";
			$connection->Execute("$req");
		}
		// Si on est au niveau de saisie 1 ou 2 et que l'tat prcdent n'est pas rempli, inutile de tester le niveau courant
		// car il est forcment incomplet. On met directement son tat  "false".
		if ($i>0 && !$bool_preced){
			$req = "UPDATE niv_form" .
					" SET saisie_complete='false'" .
					" WHERE code_observatoire='$code_observatoire'" .
					" AND mtd_sheet_id='$mtd_sheet_id_insert'" .
					" AND niv_saisie='$i'";
			$connection->Execute("$req");
		}
	}
	
	// -------------------------------------------
	// On construit et on affiche un message  propos de l'tat de chacun des 3 niveaux de saisie (remplis ou non).
	$message_niv = labelLang ("etat_niv_saisie","message_interface",$la,"label")." : ";
	for ($i=0;$i<=2;$i++){
		// On rcupre le label du niveau courant dans la langue de l'utilisateur.
		$aff_niv_saisie_cour = labelLang("niv_saisie_$i","elmnt_liste_interface",$la,"label");
		// On va chercher dans la base quel est l'tat de ce niveau.
		$req = "SELECT saisie_complete" .
				" FROM niv_form" .
				" WHERE code_observatoire='$code_observatoire'" .
				" AND mtd_sheet_id='$mtd_sheet_id_insert'" .
				" AND niv_saisie='$i'";
		$res = $connection->Execute("$req");
		$ligne = $res->FetchRow();
		$saisie_complete_cour = $ligne["saisie_complete"];
		// On construit le message  renvoyer.
		$message_niv .= $aff_niv_saisie_cour;
		if ($saisie_complete_cour == "true"){
			$message_niv .= " $lbl_niv_complet, ";
		}else{
			$message_niv .= " $lbl_niv_pas_complet, ";
		}
	}
	// Il faut supprimer les 2 derniers caractres (, ).
	$message_niv = substr($message_niv,0,-2);
	// On affiche le message.
	$code_corps.="<center><span class=text_$theme><b>$message_niv</b></span></center><br>\n";
}
// Fin du bloc de traitement pour l'envoi des valeurs.
// ------------------------------------------------------------------------------------------------------------------------------------
if ( $fonction=="modifier" || 
	 ($fonction=="ajouter" && $mtd_sheet_id!=$mtd_sheet_id_insert) ||
	 ($fonction=="ajouter" && $mtd_sheet_id==$mtd_sheet_id_insert && $rubr_deja_saisie)
	){
		include $chemin_appli."users/inc/recup_val.php";
}



// **************************************************************************************
// *   Bloc pour la cration et l'affichage du formulaire de saisie ou de mise  jour.  *
// **************************************************************************************
// Rmq : On va stocker l'ensemble du code HTML constituant le formulaire dans la variable $code_form.

// Initalisation du compteur de champs du formulaire.
$compt_elem_form = -1;

// Dbut de l'criture du formulaire.
//$code_form. =$code_form;

$code_corps .= "<table border=0 width=100% cellspacing=0 cellpadding=1 bgcolor='#E2E0DD'><tr width=100%><td width=100%>\n";
$code_corps .= "<form name=form0 action=\"saisie_gest.php?id_racine=$id_racine&compt=$compt&gab_name=$gab_name&fonction=$fonction&mtd_sheet_id=$mtd_sheet_id&mtd_sheet_id_insert=$mtd_sheet_id_insert&code_observatoire=$code_observatoire&titre_fiche=$titre_fiche_transm&niv_saisie=$niv_saisie&nom_fichier_image=$nom_fichier_image\" method=post>";// onSubmit='return verifOblig(this)'>";

// On rcupre le nombre d'occurence possible pour la section de la norme concerne par le formulaire.
$req_occ = "SELECT max_occ_gab" .
		" FROM elmnt_gabarit" .
		" WHERE elmnt_mtd_id='$id_racine'";
$res_occ = $connection->Execute("$req_occ");
$tmp = $res_occ->FetchRow();

//$tmp2 = "nb_ex_init_5000";

//global $$tmp2;


// On appelle la fonction ajouterElemGab avec l'identifiant de l'lment correspondant  la section de la norme slectionne dans
// la fentre de gauche. Cette valeur est contenu dans la variable $id_racine.
// On spcifie galement l'indice de suffixe pour cet lment et le nombre d'occurences max de la section.
// C'est  partir de cet appel que va tre construit l'intgralit du formulaire grce  des appels rcursifs de la fonction.
ajouterElemGab($id_racine,$compt,$tmp["max_occ_gab"],true);

// On ferme le tableau HTML qui contient le formulaire.
$code_corps .= "</td></tr></table>";
//$code_corps .= "</td></tr></table><br/><br/>";

// On crit le bouton submit et on ferme le formulaire.
$intit_cour = labelLang("submit","message_interface",$la,"label");
$compt_elem_form++;
$code_form .= "<center><input class=envoi_$theme type=submit name='envoi_valeurs' value='$intit_cour' onFocus='verifOblig(this.form)'></center>\n";
$code_form .= "<input type=hidden name='' value=''>\n";
$code_form .= "</form>";

// ------------------ DEBUT DE LA FONCTION ajouterElemGab -----------------------
// Cette fonction ajoute dans le formulaire l'lment dont l'identifiant est pass en 1er paramtre.
// Elle gre les fils de l'lment qui vont tre affichs dans le formulaire et les fonctions pour la saisie de valeurs multiples.
/* Paramtres : 
* identifiant de l'lment racine pour la fonction
* indice de l'lment dans la hirarchie du formulaire
* nombre d'occurences max de l'lment. 
*/

function ajouterElemGab($id_racine,$compt,$max_occ_rubr,$rubPrincipal=false){
	// On utilise des variables globales dans la fonction 
	global $mtd_sheet_id_insert;
	global $code_observatoire;
	global $connection; // connection vers la base
	global $gab_name; // nom du gabarit
	global $niv_saisie; // niveau de saisie
	global $code_form; // variable dans laquelle on crit le code du formulaire
	global $synchro;
	global $compt_elem_form; // compteur des champs du formulaire
	
	// Requte pour la recherche des fils de l'lment courant (c'est  dire dont l'identifiant = $id_racine).
	$req = "SELECT elmnt_fils_id" .
			" FROM est_contenu co,elmnt_gabarit ga
			WHERE co.elmnt_pere_id='$id_racine'" .
			" AND ga.elmnt_mtd_id='$id_racine'" .
			" AND ga.gabarit_name='$gab_name'
			AND co.gabarit_name='$gab_name'" .
			" ORDER BY co.ordre ASC";
	$res = $connection->Execute("$req");
			
	// Le (ou les) fils de l'lment courant peuvent tre des classes, des rubriques ou des champs de saisie de la norme.
	// On fait un traitement pour sauter les classes dans l'affichage du formulaire (on affiche les fils de la classe  sa place).
	// On va stocker dans un tableau liste_fils les identifiants des lments qui seront les fils de l'lment courant dans le formulaire.
	$i=0;
	while ($ligne = $res->FetchRow()){
		// Rcupration de l'identifiant du fils courant et de son type.
		$elmnt_mtd_cour = $ligne["elmnt_fils_id"];
		
		$req2 = "SELECT data_type_code" .
				" FROM elmnt_mtd" .
				" WHERE elmnt_mtd_id='$elmnt_mtd_cour'";
		$res2 = $connection->Execute("$req2");
		$ligne2 = $res2->FetchRow();
		$data_type_cour = $ligne2["data_type_code"];
		
		// Cas o le fils courant est une classe : on va stocker directement ses fils (donc les petits-fils de l'lment $id_racine).
		if ($data_type_cour=="class"){
			// On va chercher les fils de la classe.
			$req3 = "SELECT elmnt_fils_id" .
			" FROM est_contenu co,elmnt_gabarit ga
			WHERE co.elmnt_pere_id='$elmnt_mtd_cour'" .
			" AND ga.elmnt_mtd_id='$elmnt_mtd_cour'" .
			" AND ga.gabarit_name='$gab_name'
			AND co.gabarit_name='$gab_name'" .
			" ORDER BY co.ordre ASC";
			$res3 = $connection->Execute("$req3");
			// On stocke dans le tableau liste_fils les fils de la classe (donc les petits-fils de l'lment $id_racine).
			while ($ligne3 = $res3->FetchRow()){
				$liste_fils[$i] = $ligne3["elmnt_fils_id"];
				$i++;
			}
		}
		// Cas o le fils courant n'est pas une classe : c'est ce fils qu'on stocke dans le tableau liste_fils.
		else{
			$liste_fils[$i] = $elmnt_mtd_cour;
			$i++;
		}
	}

	// On va stocker dans une variable $nom_rubr le nom de l'lment pour le formulaire (de la forme elmnt_[suffixe]).
	// [suffixe] est construit  partir de l'indice de suffixe $compt auquel on te le dernier caractre.
	// On stocke dans une variable $nb_ex_[$compt] le nombre d'exemplaire de l'lment
	// courant  afficher (gestion des valeurs multiples).
	$suff_submit = substr($compt,0,-1);
	// Base pour le nom de la variable contenant la valeur + ou - de l'lment  valeurs multiples qui a t cliqu.
	$nom_rubr = "elmnt_".$suff_submit;
	// Rcupration du nombre d'exemplaire de l'lment courant  afficher.
	$ex_rubr = "nb_ex_".$compt;
	global $$ex_rubr;
	// $$ex_rubr <=> $nb_ex_[$compt]. 
	// Si cette valeur est vide, on rcupre le nombre d'lments depuis $nb_ex_init_[$compt] ou on le met = 1.
	// Si on est arriv sur le formulaire depuis l'interface de mise  jour ou depuis l'interface de cration  partir
	// d'une fiche existante, la valeur de $nb_ex_init_[$compt] est non nulle (affecte par le fichier users/inc/recup_val.php).
	
	
	if ($$ex_rubr==""){
		// On rcupre la valeur de $nb_ex_init_[$compt].
		$tmp = "nb_ex_init_".$compt;
		global $$tmp;
		// Cette valeur est nulle, on est rentr par la cration d'une nouvelle fiche, on affiche un seul exemplaire de l'lment.
		if ($$tmp=="" || $$tmp==0){
			  $$ex_rubr=1;
		}
		// Elle est non nulle, on rcupre la valeur provenant du fichier users/inc/recup_val.php.
		// On affichera ainsi autant de fois l'lment qu'on a rcupr de valeurs depuis la base.
		else{
			$$ex_rubr=$$tmp;
		}
	}
	// Cette portion gre l'incrmentation et la dcrmentation du nombre d'exemplaires d'un champ  valeurs multiples.
	// Elle sert aussi  crire le code Javascript qui permet de rafficher le formulaire au niveau de l'ancre associe au bouton + ou - sur lequel on a cliqu avant de lancer le rechargement de la page. Cela vite de revenir en haut du formulaire.
	// On parcourt chacun des exemplaires possibles pour l'lment concern.
	// La variable $compt_optim permet d'optimiser le code en arrtant le parcours des indices possibles  la valeur correspondant au nombre d'exemplaire du champ avant le clic sur + ou -.
	// La fonction indSuiv permet d'incrmenter l'indice (voir /users/inc/fonctions.inc.php).	
	$compt_optim = 0;
	$stop_optim = $$ex_rubr;
	
	//CAS POUR UNE RUBRIQUE MULTIPLE
	
	for ($car="0",$car2="0";$car!="/",$compt_optim<=$stop_optim;$car=indSuiv($car)){
		// On incrmente $car2 avec un dcalage de 1 par rapport  $car.
		if ($car>"1") {$car2 = indSuiv($car2);}
		// On construit le nom complet de la variable contenant la valeur + ou -.
		$nom_rubr_complet = $nom_rubr.$car;
		// On rcupre la valeur contenu dans la variable.
		global $$nom_rubr_complet;
		// Si la valeur n'est pas nulle, on traite le cas du clic sur + ou sur -.
		global $code_ancre;
		
		if (isset($$nom_rubr_complet)){
			if ($$nom_rubr_complet=="+"){ 
				// On a cliqu sur +, il faut ajouter un exemplaire du champ. 
				$$ex_rubr++;
				// On fait pointer le rechargement sur l'lment o on avait cliqu.
				$code_ancre ="<script language='Javascript'>document.location.href='#".$nom_rubr_complet."';</script>";
				//$code_form .= "<script language=Javascript>document.location.href='#$nom_rubr_complet';</script>";
			}
			if ($$nom_rubr_complet=="-"){ 
				// On a cliqu sur -, il faut ter un exemplaire du champ. 
				$$ex_rubr--; 
				$nom_rubr_complet2=$nom_rubr.$car2; 
				// On fait pointer le rechargement sur l'lment prcdent celui cliqu.
				$code_ancre="<script language='Javascript'>document.location.href='#".$nom_rubr_complet2."';</script>";
//				$code_form .= "<script language=Javascript>document.location.href='#$nom_rubr_complet2';</script>";
			}
			// Ds qu'on a trouv l'exemplaire qui a t cliqu, pas besoin de chercher les autres. On arrte la boucle.
			break;
		}
		$compt_optim++;
	}

	// On traite ici le cas o on se retrouve avec plus d'exemplaire que le maximum autoris par le gabarit. Dans ce cas, on prend le max du gabarit comme nombre d'exemplaires.	
	$$ex_rubr=$$ex_rubr+0;
	if ($$ex_rubr>$max_occ_rubr){
		$$ex_rubr=$max_occ_rubr;
	 }
	// On mmorise le nombre d'exemplaires finalement obtenu.
	$max_compt_rubr = $$ex_rubr;
	$visibilite=$synchro->getNiveauVisibilite($id_racine,$gab_name);
	if (aPourNiveauSaisie($id_racine,$gab_name,$niv_saisie) && 
			($visibilite=="" || ($visibilite>=3 && $visibilite<=6))){
		// On incrmente le compteur d'lment du formulaire et on ajoute un champ cach contenant le nombre d'exemplaire du champ (pour le transmettre si on rappelle le script en cliquant sur un + ou un -).
		$compt_elem_form++;
		$code_form .= "<input type=hidden name=".$ex_rubr." value='".$$ex_rubr."'>\n";
		$compt_elem_form++;
		$code_form .= "<input type=hidden name=".$id_racine."_".$compt." value='".$$ex_rubr."'>\n";
		
	}
	// Dans ce bloc, on va lancer l'criture des diffrents exemplaires de champs pour l'lment courant, ainsi que le traitement pour ses fils directs tels que dfinis dans le tableau liste_fils prcdemment rempli.
	// Ce sont les appels  la fonction ecrireElemForm qui permettent d'crire les champs de saisie du formulaire. 
	// NB: On ne peut crire au maximum que 62 exemplaires pour un champ ( cause de la mthode utilise pour le calcul des indices, voir /users/inc/fonctions.inc.php).
	for ($i=0;$i<min($max_compt_rubr,63);$i++,$compt=indSuiv($compt)){
		// Si l'lment courant a un niveau de saisie correspondant  celui choisi pour l'affichage du formulaire, on lance l'criture du champ.
		// La fonction aPourNiveauSaisie provient du script /config/fonctions.inc.php
		// Pour les paramtres de la fonction ecrireElemForm voir plus bas dans ce script.
		// et si l'elemnt ne doit pas tre cach (invisible, default ou prdfinie)
		//$niveau_saisise=$synchro.estVisible($id_racine,$gab_name);
		//if (aPourNiveauSaisie($id_racine,$gab_name,$niv_saisie) && $niveau_saisie_element>=0)
		if (aPourNiveauSaisie($id_racine,$gab_name,$niv_saisie)
			&& ($visibilite=="" || ($visibilite>=3 && $visibilite<=6)) ){ 
		//echo "niv saisie= ".$niv_saisie." ok.";
		//echo "saisie=".aPourNiveauSaisie($id_racine,$gab_name,$niv_saisie)." ok.";  
			if ($rubPrincipal){
				$rubPrincipal=true;
			}else{
				$rubPrincipal=false;
			}
			ecrireElemForm($id_racine,$compt,true,$max_occ_rubr>1,$$ex_rubr<$max_occ_rubr,$$ex_rubr>1,$i,$rubPrincipal,$max_compt_rubr);
		}
		
		// On va maintenant traiter les fils directs de l'lment courant.
		$j=0;
		for ($f=0;$f<count($liste_fils);$f++){
			// On rcupre l'identifiant du fils courant dans le tableau liste_fils, puis on va chercher ses caractristiques dfinies dans le gabarit et la norme (son nombre d'ocurrences max et son type).
			$elmnt_mtd_cour = $liste_fils[$f];
			$req_occ = "SELECT max_occ_gab, data_type_code" .
					" FROM elmnt_gabarit ga,elmnt_mtd mtd" .
					" WHERE ga.elmnt_mtd_id='$elmnt_mtd_cour'" .
					" AND ga.gabarit_name='$gab_name'" .
					" AND mtd.elmnt_mtd_id='$elmnt_mtd_cour'";
			$res_occ = $connection->Execute("$req_occ");
			$ligne_occ = $res_occ->FetchRow();
			$data_type_cour = $ligne_occ["data_type_code"];
			$max_occ_cour = $ligne_occ["max_occ_gab"];
			
			// Si le type du fils courant est un rubrique, on construit son indice  partir de celui du pre ($compt) en ajoutant l'ordre du fils courant ($j) puis un 0 pour initialiser le niveau suivant dans la hirarchie.
			// On fait un appel rcursif sur la fonction ajouterElemGab pour traiter le contenu de cette rubrique.
			if ($data_type_cour=="rubrique"){
				$par_appel = $compt.$j."0"; $j=indSuiv($j);
				ajouterElemGab($elmnt_mtd_cour,$par_appel,$max_occ_cour);
			}
			// Si le fils courant n'est pas une rubrique, alors c'est forcment un lment valu (on a supprim les classes de la norme dans le tableau liste_fils).
			// On crit donc directement le champ de saisie associ  ce fils (pas besoin de faire un appel rcursif).
			else{
				// Si le fils courant a pour nombre d'occurences max 1 (une seule valeur possible), on crit le champ correspondant.
				if ($max_occ_cour<=1){
					// L'indice est construit avec celui de l'lment pre concatn  l'ordre du fils courant ($j).
					$suffixe = $compt.$j; $j=indSuiv($j);
					// On crit le champ de formulaire si l'lment a le niveau de saisie choisi.
					//et si ce n'est pas element  cacher (invsible ou default ou prdfinie) 
					$visibilite=$synchro->getNiveauVisibilite($elmnt_mtd_cour,$gab_name);
					if (aPourNiveauSaisie($elmnt_mtd_cour,$gab_name,$niv_saisie) && ($visibilite=="" || $visibilite==3) ){ 
						ecrireElemForm($elmnt_mtd_cour,$suffixe,false,false,false,false,$i,false,$max_compt_rubr);
					}
				}
				
				//CAS ELEMENT MULTIPLE
				// Si le fils courant est un lment qui peut avoir des valeurs multiples,
				// il faut galement grer les champs multiples de ce fils et les boutons + - associs.
				// En fait on va faire le mme traitement que pour l'lment pre si il admet des valeurs multiples
				// (voir plus haut dans ce script pour les commentaires : l 300->363).
				else{
					$nom_elem = "elmnt_".$compt.$j;
					$ex_elem = "nb_ex_".$compt.$j."0";
					global $$nom_elem;
					global $$ex_elem;
					if ($$ex_elem==""){
						$tmp = "nb_ex_init_".$compt.$j."0";
						global $$tmp;
						if ($$tmp=="") { $$ex_elem=1; }
						else { $$ex_elem=$$tmp; }
					}					
					$compt_optim = 0;
					$stop_optim = $$ex_elem;
					for ($car="0",$car2="0";$car!="/",$compt_optim<=$stop_optim;$car=indSuiv($car)){
						if ($car>"1") {$car2 = indSuiv($car2);}
						$nom_elem_complet = $nom_elem.$car;
						global $$nom_elem_complet;
						global $code_ancre;
						
						if (isset($$nom_elem_complet)){
							if ($$nom_elem_complet=="+"){ 
								$$ex_elem++;
								$code_ancre = "<script language='Javascript'>window.location.href='#".$nom_elem_complet."'</script>";
							//	$code_form .= "<script language='Javascript'>window.location.href='#$nom_elem_complet';</script>";
							}
							if ($$nom_elem_complet=="-"){ 
								$$ex_elem--; 
								$nom_elem_complet2=$nom_elem.$car2; 
								//$code_form .= "<script language=Javascript>window.location.href='#$nom_elem_complet2';</script>";
								$code_ancre = "<script language='Javascript'>window.location.href='#".$nom_elem_complet2."';</script>";
							}
							break;
						}
					 $compt_optim++;
					}
					
					// On traite ici le cas o on se retrouve avec plus d'exemplaire que le maximum autoris par le gabarit. Dans ce cas, on prend le max du gabarit comme nombre d'exemplaires.	
					if ($$ex_elem>$max_occ_cour) { $$ex_elem=$max_occ_cour; }

					// On mmorise le nombre d'exemplaires finalement obtenu.
					$max_compt_elem = $$ex_elem;
					// On incrmente le compteur d'lment du formulaire et on ajoute un champ cach contenant le nombre d'exemplaire du champ (pour le transmettre si on rappelle le script en cliquant sur un + ou un -).
					$visibilite=$synchro->getNiveauVisibilite($elmnt_mtd_cour,$gab_name);
					if (aPourNiveauSaisie($elmnt_mtd_cour,$gab_name,$niv_saisie) && ($visibilite=="" || $visibilite==3) ){
						$compt_elem_form++;
						$code_form .= "<input type=hidden name=".$ex_elem." value='".$$ex_elem."'>\n";
					}
					// Dans ce bloc, on va lancer l'criture des diffrents exemplaires de champs pour le fils courant.
					// Ce sont les appels  la fonction ecrireElemForm qui permettent d'crire les champs de saisie du formulaire. 
					// NB: On ne peut crire au maximum que 62 exemplaires pour un champ ( cause de la mthode utilise pour le calcul des indices, voir /users/inc/fonctions.inc.php).
					for ($k=0,$k2=0;$k<min($max_compt_elem,63);$k++){ 
						// L'indice est construit avec celui de l'lment pre concatn  l'ordre du fils courant ($j) puis une valeur incrmente qui indique l'index de l'occurence concerne.
						$suffixe = $compt.$j.$k2; $k2 = indSuiv($k2);
						// On crit le champ de formulaire si l'lment a le niveau de saisie choisi.
						$visibilite=$synchro->getNiveauVisibilite($elmnt_mtd_cour,$gab_name);
						if (aPourNiveauSaisie($elmnt_mtd_cour,$gab_name,$niv_saisie) && ($visibilite=="" || $visibilite==3) ){ 
							ecrireElemForm($elmnt_mtd_cour,$suffixe,false,true,$$ex_elem<$max_occ_cour,$$ex_elem>1,$i,false,$max_compt_rubr);
						}
					}
					$j=indSuiv($j);
				}
			}
		}
	}
	$compteurperso++;
}
// --------------- FIN DE LA FONCTION ajouterElemGab -------------------------


// ------------------ DEBUT DE LA FONCTION ecrireElemForm -----------------------
// Cette fonction gre l'affichage dans le formulaire du champ de saisie pass en paramtre.
/* Paramtres : 
* identifiant de l'lment dans la norme
* indice du champ que l'on veut afficher dans la hirarchie du formulaire
* boolen qui indique si l'lment est une rubrique
* boolen qui indique si l'lment accepte des valeurs multiples
* boolen qui indique si on peut ajouter d'autres valeurs (affichage du bouton +)
* boolen qui indique si on peut enlever des valeurs (affichage du bouton -)
* optionnel : numro de l'occurence d'une rubrique (affichage de [1],[2],...  ct de l'intitul des rubriques)
*/

	function ecrireElemForm($id_elmnt,$suffixe,$bool_rubr,$bool_occ,$bool_plus,$bool_moins,$num_rubr=0,$rubPrincipal=false,$rub_occ){
 	
 		 $compteurperso++;
 		 
	// On utilise des variables globales dans la fonction 
	global $connection; // connection vers la base
	global $gab_name; // nom du gabarit
	global $code_form; // variable dans laquelle on crit le code du formulaire
	global $compt_elem_form; // compteur des champs du formulaire
	global $la; // langue choisie par l'utilisateur
	global $theme; // theme de coucleur choisi par l'utilisateur
	global $url_site; // URL du site pour le chemin d'accs aux fichiers inclus
	global $alias_appli; // nom de l'appli pour complter le chemin prcdent
	global $liste_chp_oblig; // la liste des champs obligatoires  la saisie (remplie par les appels  cette fonction pour tous les champs du formulaire).
	global $bool_def_val; // vrai si on est arriv depuis l'interface de cration sans utiliser une fiche existante
	global $titre_fiche; // titre de la fiche de mtadonnes
	global $compt_textarea; // variable utilise pour le code HTML du compteur spcifique aux champs de type textarea
  	global $erreur;
	global $firstPrint;
	global $style;
	global $nb_extent_geom;
	$compt_textarea = "";
	
	// On va chercher dans la norme si l'lment correspondant au champ que l'on
	// veut afficher est un lment implment par une liste de la norme.
	// On rcupre le nom de la liste (un caractre espace si l'lment n'est pas implment par une liste).
	$req3 = "SELECT list_short_name" .
			" FROM elmnt_mtd" .
			" WHERE elmnt_mtd_id='$id_elmnt'";
	$res3 = $connection->Execute("$req3");
	$ligne3 = $res3->FetchRow();
	//$intit_chp = $ligne3["elmnt_name"];
	$list_short_name = $ligne3["list_short_name"];
/*$req4 = "SELECT style" .
			" FROM elmnt_gabarit" .
			" WHERE elmnt_mtd_id='$id_elmnt'" .
			" AND gabarit_name='$gab_name'";
	$res4 = $connection->Execute("$req4");
	$ligne4 = $res4->FetchRow();
	$style = $ligne4["style"];
	if ($style==""){
		$style="elmnt";	
	}
*/	
	// On se base sur l'indice du champ pour dterminer le nombre de tabulation  afficher  gauche de son intitul.
	$nb_chif = strlen($suffixe);
	$nb_tab = floor(($nb_chif-1)/2);

	//SAUT DE LIGNE OU PAS ENTRE CHAQUE champs
	//$code_form .= "<br>";
	//INDENTATION
	//for ($i=0;$i<$nb_tab;$i++) { $code_form .= "&nbsp;&nbsp;&nbsp;&nbsp;"; }
	
	// Si l'lment peut avoir des valeurs multiples, on affiche des boutons + et -  gauche de l'intitul du champ.
	// On incrmente de compteur de champs du formulaire car ces boutons sont eux-mmes des champs.
	$req4 = "SELECT style" .
			" FROM elmnt_gabarit" .
			" WHERE elmnt_mtd_id='$id_elmnt'" .
			" AND gabarit_name='$gab_name'";
	$res4 = $connection->Execute("$req4");
	while($ligne4 = $res4->FetchRow()){
		$style = $ligne4["style"];
	}
	if ($style==""){
		$style="elmnt";	
	}
	if (!$firstPrint){
		//$code_form .= "<br>";
		if ($style=="rub" || $bool_rubr){
			$code_form .="<hr align='left'  width='100%'>";	
		}		
	}elseif(!$rubPrincipal){
			$code_form .="<hr align='left' width='100%'>";	
	}
	$code_form.="<table witdh='100%' cellpadding='1' cellspacing='0' bgcolor='#E2E0DD'><tr>";
	if ($bool_occ){ 
		$code_form.="<td valign='middle'>";
		// Si on peut encore ajouter des valeurs, on affiche le bouton +.
		if ($bool_plus) { $compt_elem_form++; $code_form .= "<input type=submit name=elmnt_$suffixe value='+'>"; }
		// Si on peut encore ter des valeurs, on affiche le bouton -.
		if ($bool_moins) { $compt_elem_form++; $code_form .= "<input type=submit name=elmnt_$suffixe value='-'>"; }
		$code_form .= " \n";
 		$code_form.="&nbsp;&nbsp;&nbsp;</td>";
	}

	// Nom de la variable contenant la valeur du champ correspondant  l'indice.
	
	$nom_chp_form = $id_elmnt."_".$suffixe;
	//echo "var=".$nom_chp_form.".<br>";
	// On rcupre la valeur dj saisie dans le champ (charge dans /users/inc/recup_val.php).
	global $$nom_chp_form;
	//echo "value=".$$nom_chp_form.".<br>";
	
	// Pour chaque champ de saisie, on ajoute un ancre dont le nom est base sur l'indice
	// (ancre qui est pointe en javascript si on recharge le formulaire  partir d'un bouton + ou -).
	$code_form .= "<a name='elmnt_$suffixe'></a>";
	
	// Rcupration depuis la base de l'intitul de l'lment dans la langue choisie par l'utilisateur (la fonction labelLang se trouve dans le fichier /config/fonctions.inc.php).
	$intit_elem_cour = labelLang($id_elmnt,"elmnt_mtd",$la,"label_stand");
	$intit_elem_cour = ucfirst(strtolower($intit_elem_cour));
	
	// Si l'lment est une rubrique on affiche le numro de l'occurence entre []  ct de l'intitul.
	// et si rubrique visible
	$code_form.="<td valign='middle'>";
	if ($bool_rubr){
		$aff=$num_rubr+1;
		if ($rubPrincipal){
			$color="#990000";
		}else{
			$color="black";
			$code_form .= "<font color=$color face='Verdana' size=1><b><a class='menulink' href='".$url_site.$alias_appli."aide/glossary_$la.html#$id_elmnt' target='_blank'>" .
			$intit_elem_cour."&nbsp;[$aff]</a></font></b></font>&nbsp;&nbsp;<br><br>";
			$firstPrint=0;
			//Attention => A rendre gnrique
			
			if($id_elmnt=="geographicElement_141"){
				$nb_extent_geom=$aff;
			}
		}	
	}
	// Si l'lment n'est pas une rubrique (champ valu) on affiche seulement l'intitul.
	// et si l'lement n'est pas une valeur par dfault ou prdfinie
	else{
		$intit_elem_cour=nl2br($intit_elem_cour);
		if (!strstr($nom_chp_form,"parentIdentifier_5")) {
			$code_form .= "<font class=text_$theme><a class='normal' href='".$url_site.$alias_appli."aide/glossary_$la.html#$id_elmnt' target='_blank'>$intit_elem_cour</a></font>&nbsp;&nbsp;";
		}
	}
	$code_form.="</td>";
	// Si l'lment n'est pas une rubrique (champ valu), il faut afficher le champ de saisie.
	// ET si l'lement n'est pas une valeur par dfault
	
	if (!$bool_rubr){ 
		//On va chercher dans la base si l'lment correspondant
		// est obligatoire et sa valeur par dfaut prconise par la norme.
		$req = "SELECT mandt_code_gab, default_val" .
				" FROM elmnt_gabarit" .
				" WHERE gabarit_name='$gab_name'" .
				" AND elmnt_mtd_id='$id_elmnt'";
		$res = $connection->Execute("$req");
		$ligne = $res->FetchRow();
		$oblig_chp_cour = $ligne["mandt_code_gab"];
		$default_val = $ligne["default_val"];
		
		// On rcupre le type de donnes associ  l'lment de la norme.
		// Pour les lments valus, on peut avoir un des types suivants : text,integer,float,boolean,date,thesaurus.
		$req = "SELECT data_type_code" .
				" FROM elmnt_mtd" .
				" WHERE elmnt_mtd_id='$id_elmnt'";
		$res = $connection->Execute("$req");
		$ligne = $res->FetchRow();
		$data_type_cour = $ligne["data_type_code"];
		
		
		// On rcupre dans la base les informations sur le champ de saisie du formulaire (identifiant du champ, type du champ, tailles horizontale et verticale).
		// Le champ de saisie peut avoir un des types suivants : readonly, text, textarea, select.
		// Le type readonly est un champ dont la valeur est pr-remplie et ne peut pas tre change (sauf indirectement dans le cas d'un lment de thsaurus).
		$req = "SELECT field_id,field_type,hor_size_text,vert_size_text" .
				" FROM field_elmnt" .
				" WHERE gabarit_name='$gab_name'" .
				" AND elmnt_mtd_id='$id_elmnt'";
		$res = $connection->Execute("$req");
		$ligne = $res->FetchRow();
		$field_id = $ligne["field_id"]; // identifiant du champ de saisie
		$field_type = $ligne["field_type"]; // type du champ de saisie
		$hor_size = $ligne["hor_size_text"]; // taille horizontale
		$vert_size = $ligne["vert_size_text"]; // taille verticale
		//$erreur .= "<br>element = ".$intit_elem_cour."<br>"."type = ".$field_type;
		
		// Si on est arriv depuis l'interface de cration en partant d'une fiche vierge, on va afficher dans le champ de saisie la valeur par dfaut prconise par la norme.
		//if ($bool_def_val){
			if ($$nom_chp_form=="" && $default_val!=""){
				$$nom_chp_form=$default_val;
			}
		//}
		$$nom_chp_form=stripslashes($$nom_chp_form);
		
		// Dans la suite du code de cette fonction, on va maintenant traiter l'affichage du champ de saisie en fonction de son type.
		// Cas d'un champ readonly qui ne correspond pas  un lment de type thesaurus.
		if ($field_type=="readonly" && $data_type_cour!="thesaurus"){
			// La valeur  mettre dans le champ readonly dpend de l'lment de la norme concern par ce champ.
			// Cas du titre de la fiche.
			//calcul de l'identifiant de la fiche si il n'existe pas
			if ($id_elmnt=="fileIdentifier_2"){
				if ($$nom_chp_form ==""){
					global $code_observatoire;
					global $mtd_sheet_id_insert;
					//$$nom_chp_form = $titre_fiche;
					$$nom_chp_form="MDWeb_".$code_observatoire."_".$gab_name."_".$mtd_sheet_id_insert;
				}
			}
			//cas de l'identifiant parent
			$maj_sheet_parent=false;
			if ($id_elmnt=="parentIdentifier_5"){
				if ($$nom_chp_form ==""){
					//recherche d'un ou plusieurs id parent si il existe
					global $code_observatoire;
					global $mtd_sheet_id_insert;
					$req="SELECT mtd_value from mtd_value" .
							" WHERE mtd_sheet_id='$mtd_sheet_id_insert'" .
							" AND code_observatoire='$code_observatoire'
									 AND elmnt_mtd_id='parentIdentifier_5'";
					$res=$connection->Execute($req);
					$ecrire_nom_element=true;
					$index=0;
					$nom_chp_form=$nom_chp_form.$index;
					while($ligne=$res->FetchRow()){
						//$$nom_chp_form = $titre_fiche;
						$$nom_chp_form= $ligne['mtd_value'];
						$maj_sheet_parent=true;
						// On incrmente le compteur de champ du formulaire.
						$compt_elem_form++;
						// On crit le champ en lecture seule avec un javascript qui pointe sur le champ suivant si on essaye de l'activer.
						$tmp=$compt_elem_form+1;
						$code_form .= "<td valign='middle'>";
						$code_form .= "<font class=text_$theme>$intit_elem_cour</font>&nbsp;&nbsp;";
						$code_form .= "<input type=text readonly class=readonly2 onFocus='form0.elements[".$tmp."].focus();' size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\"><br>";
						$code_form .= "</td>";
						//if ($res->RecordCount()>1 && $ecrire_nom_element) {
							$nom_chp_form++;	
						$ecrire_nom_element=false;
						//}
						$index++;
					}
					if ($ecrire_nom_element) {
						$code_form .= "<font class=text_$theme>$intit_elem_cour</font>&nbsp;&nbsp;";
					}
				}
			}
			// Cas de la date de saisie de la fiche.
			if ($id_elmnt=="dateStamp_9") { $$nom_chp_form = date("d-m-Y"); }
			// Cas de la version de la norme de mtadonnes (= au nom du gabarit pour nous).
			if ($id_elmnt=="metadataStandardVersion_35") { $$nom_chp_form = labelLang($gab_name,"gabarit_mtd",$la,"label"); }
			// Cas du nom de la norme de mtadonnes.
			if ($id_elmnt=="metadataStandardName_34"){
				$req = "SELECT stan_vers " .
						"FROM standard " .
						"WHERE stan_name='ISO 19115'";
				$res = $connection->Execute("$req");
				$ligne = $res->FetchRow();
				$$nom_chp_form = "ISO 19115 - ".$ligne["stan_vers"];
			} 
			if (!$maj_sheet_parent) {
				//$erreur .= "element= ".$nom_chp_form;
				// On incrmente le compteur de champ du formulaire.
				$compt_elem_form++;
				// On crit le champ en lecture seule avec un javascript qui pointe sur le champ suivant si on essaye de l'activer.
				//if ($compt_elem_form > 5) {$tmp=$compt_elem_form+1;$element_suivant=$compt_elem_form-1;}
				//else {$element_suivant=$compt_elem_form;}
				$code_form .= "<td valign='middle'><input type=text readonly class=readonly2 onFocus='form0.elements[".$tmp."].focus();' size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\"></td>";
			}
			// Si la saisie de la valeur est obligatoire, on ajoute le champ dans la liste des valeurs obligatoires.
			if ($oblig_chp_cour=="true"){ $liste_chp_oblig["$nom_chp_form"] = $compt_elem_form; }
		}
		// Cas d'un champ de type thesaurus.
		if ($data_type_cour=="thesaurus" && ($field_type=="text" || $field_type=="readonly")){
			// On incrmente le compteur de champ du formulaire.
			/*if($id_elmnt!="code_133"){
				// On ajoute un champ cach qui va contenir l'identifiant de l'lment de thsaurus slectionn.
				$code_form .= "<input type=hidden name=$nom_chp_form value='$id_elmnt_thes_cour'>";
				ereg ("^keyword_269_([0-9a-zA-Z]+)$",$nom_chp_form,$corresp);
				$num_elmnt_cour = $corresp[1];
				$num_elmnt_cour=substr_replace($num_elmnt_cour,"",-1);
				$thesaurus_id="title_515_".$num_elmnt_cour."100";
				global $$thesaurus_id; 
				$temporaire=$$thesaurus_id;	
				$code_form .= "<input type=hidden name='thesaurus_id_".$nom_chp_form."' value='$temporaire'>";
				$compt_elem_form+=2;
			}*/
						
			if ($field_type=="text"){
				global $nb_keywords;
				$nb_keywords++;
				// On rcupre le libell de l'lment de thsaurus dj prsent dans le champ en lecture seule.
				$nom_chp_thes_cour = "thesaurus_".$nom_chp_form;
				global $$nom_chp_form;
				global $$nom_chp_thes_cour;
				$id_thes_2="thesaurus_id_".$nom_chp_form;
				global $$id_thes_2;
				//cas keyword_269 esxiste
				if ($$nom_chp_form!=""){
					$id_elmnt_thes_cour = $$nom_chp_form;
					$lbl_elmnt_thes_cour = labelLang("$id_elmnt_thes_cour","elmnt_thesaurus",$la,"label");
					if ($lbl_elmnt_thes_cour==""){
						$lbl_elmnt_thes_cour=$$nom_chp_form;
						$id_elmnt_thes_cour="";
					}else{
						if ($$id_thes_2==""){
							$$id_thes_2=getThesaurusName($id_elmnt_thes_cour);
						}
					}		
				}elseif($$nom_chp_thes_cour!=""){
					$lbl_elmnt_thes_cour=$$nom_chp_thes_cour;
				}
									
				//EN COURS DEMAIN
				$code_form .= "\n<input type=hidden name='$nom_chp_form' id='$nom_chp_form' value=\"".$$nom_chp_form."\">\n";
				//EN COURS DEMAIN
				$compt_elem_form++;
				// On crit le champ en lecture seule avec un javascript qui pointe sur le champ suivant si on essaye de l'activer.
				
				/*SPECIAL CAP VERT*/
				//$code_form .= "<td valigne='middle'><input type=text class=readonly2 size=$hor_size name=$nom_chp_thes_cour value=\"$lbl_elmnt_thes_cour\" onKeypress=\"eraseKeyword('form0','$nom_chp_form')\"></td>\n";
				$code_form .= "<td valigne='middle'>";
				//$code_form .="<input type='text' class='readonly2' id='$nom_chp_thes_cour'  size='$hor_size' name='$nom_chp_thes_cour' value=\"$lbl_elmnt_thes_cour\" onKeypress=\"eraseKeyword('form0','$nom_chp_form');\" onkeyup=\"SendQuery(this.value,this.name);\" onBlur=\"selectw('onBlurKeyword','');\" autocomplete=\"off\" />\n";
				$code_form .="<input type='text' class='readonly2' id='$nom_chp_thes_cour'  size='$hor_size' name='$nom_chp_thes_cour' value=\"$lbl_elmnt_thes_cour\" onKeypress=\"eraseKeyword('form0','$nom_chp_form');\" onkeyup=\"SendQuery(this.value,this.name,'$theme','$la','$nb_keywords');\" autocomplete=\"off\" />\n";
				
				//$code_form .="<input type='text' class='readonly2' id='$nom_chp_thes_cour'  size='$hor_size' name='$nom_chp_thes_cour' value=\"$lbl_elmnt_thes_cour\" onkeyup=\"SendQuery(this.value,this.name);\"  autocomplete=\"off\" />\n";
				
				$code_form .="<br/><DIV class=\"listres\" id=\"autocomplete_$nb_keywords\" style=\"VISIBILITY: hidden; align=\"left\" z-order=\"\"></DIV></td>";
				/*FIN SPECIAL CAP VERT*/
				
				$compt_elem_form++;
			}elseif ($id_elmnt=="code_133"){
				global $web_carto;
								
				if ($web_carto){
					//$code_form .= "<td valigne='middle'><input type='text' class='readonly2' name='$nom_chp_form' id='geographic_identifier_$nb_extent_geom' onFocus='form0.elements[".$compt_elem_form."].focus();' size=$hor_size value=\"".$$nom_chp_form."\"></td>\n";
					$code_form .= "<td valigne='middle'><input type='text' class='readonly2' name='$nom_chp_form' id='geographic_identifier_$nb_extent_geom' size=$hor_size value=\"".$$nom_chp_form."\"></td>\n";
				
				}else{
					$code_form .= "<td valigne='middle'><input type='text' class='readonly2' name='$nom_chp_form' id='geographic_identifier_$nb_extent_geom' size=$hor_size value=\"".$$nom_chp_form."\"></td>\n";
				}
				$compt_elem_form++;
				global $web_carto_button;
				global $lang;
			}
			if ($oblig_chp_cour=="true"){
				$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
			}
			if (!$web_carto_button && $id_elmnt=="code_133"){
				global $web_carto;
				//si il y appel  carto web => pas de thesaurus pour l'identifinat geo
				if ($web_carto){
					$code_form .= "<td valigne='middle'><a name=latlong_$suffixe href='#latlong_$suffixe' onClick=\"saisLatLong('formLatLong','$lang','$nb_extent_geom')\">";
					$code_form .= "&nbsp;&nbsp;&nbsp;<img border=0 align=absmiddle src='".$url_site.$alias_appli."img/carto_web.gif'></a></td>";			
					$code_form .= " <input type=hidden id='latlong_west_".$nb_extent_geom."'  value=\"\" />";			
					$code_form .= " <input type=hidden id='latlong_east_".$nb_extent_geom."'  value=\"\" />";			
					$code_form .= " <input type=hidden id='latlong_north_".$nb_extent_geom."'  value=\"\" />";			
					$code_form .= " <input type=hidden id='latlong_south_".$nb_extent_geom."'  value=\"\" />";			
					$compt_elem_form+=4;	
				//sinon appel  thseaurus identifiant gographique --- A IMPLEMENTER -- TODO
				}else{
					
				}
			}elseif(!$web_carto_button){
				$code_form .= "\n<input type=hidden name='$id_thes_2' value=\"".$$id_thes_2."\" />\n";
				$compt_elem_form++;
				$code_form .= "<td valigne='middle'><a name=$nom_chp_thes_cour_2 href=\"#$nom_chp_thes_cour\" onClick=\"saisKeywords('form0','$nom_chp_form','$la','$theme')\">";
				$code_form .= "&nbsp;&nbsp;&nbsp;<img border=0 align=absmiddle src='".$url_site.$alias_appli."img/thesaurus.gif'></a></td>\n";
			}
		}
				
		// Cas d'un champ de type text.
		if ($data_type_cour!='thesaurus' && ($field_type=="text" || $field_type=="mail")){
			// On incrmente le compteur de champ du formulaire.
			$compt_elem_form++;
			// On crit le champ de type text en appelant la fonction construireContrJs pour l'appel du contrle javascript associ  ce champ (voir plus bas dans ce script pour les dtails sur cette fonction).
			//test nombre exemplaire pour la rubrique
			if(preg_match("|westBoundLongitude_[0-9]+$|",$id_elmnt)){	
				global $lang;
				$code_form .= " <td valigne='middle'>" .
						"<input type=text id='latlong_west_".$nb_extent_geom."' size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\" ";
				$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
				$code_form .= "onchange=\"calculIdGeom(this.form,$nb_extent_geom);\"";
				$code_form .= ">";
				if ($oblig_chp_cour=="true"){
					$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
					$code_form .= "&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=3>*</font>\n";
				}
				global $web_carto;
				if ($web_carto){
					$code_form .= "<a name=latlong_$suffixe href='#latlong_$suffixe' onClick=\"saisLatLong('formLatLong','$lang','".$nb_extent_geom."')\">";
					$code_form .= "<img border=0 align=absmiddle src='".$url_site.$alias_appli."img/carto_web.gif'></a>";			
				}
				$oblig_chp_cour="false";
				global $web_carto_button;
				$web_carto_button=true;
				$code_form .="</td>";
				
			}elseif(preg_match("|eastBoundLongitude_[0-9]+$|",$id_elmnt)){
				global $lang;
				$code_form .="</td>";
				
				$code_form .= " <td valigne='middle'><input type=text id='latlong_east_".$nb_extent_geom."' size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\" ";
				$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
				$code_form .= "onchange=\"calculIdGeom(this.form,'$nb_extent_geom');\"";
				$code_form .= ">";
				if ($oblig_chp_cour=="true"){
					$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
			    	$code_form .= "&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=3>*</font>\n";
				}
				$oblig_chp_cour="false";
			
				$code_form .= "</td>";
			}elseif(preg_match("|southBoundLatitude_[0-9]+$|",$id_elmnt)){
				global $lang;
				$code_form .= " <td valigne='middle'><input type=text id='latlong_south_".$nb_extent_geom."' size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\" ";
				$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
				$code_form .= "onchange=\"calculIdGeom(this.form,'$nb_extent_geom');\"";
				$code_form .= ">";
				// Si la saisie de la valeur est obligatoire, on ajoute le champ dans la liste des valeurs obligatoires.
				//	echo "fin<br>";
				if ($oblig_chp_cour=="true"){
					$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
				 	$code_form .= "&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=3>*</font>\n";
	 			}
				$oblig_chp_cour="false";
				$code_form .= "</td>";
			}elseif(preg_match("|northBoundLatitude_[0-9]+$|",$id_elmnt)){
				global $lang;
				$code_form .= " <td valigne='middle'><input type=text id='latlong_north_".$nb_extent_geom."' size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\" ";
				$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
				$code_form .= "onchange=\"calculIdGeom(this.form,'$nb_extent_geom');\"";
				$code_form .= ">";
				if ($oblig_chp_cour=="true"){
				 	$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
				  	$code_form .= "&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=3>*</font>\n";
	 				$oblig_chp_cour="false";
	 			}
				
				$code_form .= "</td>";
			}else{
				$code_form .= "<td valign='middle'> <input type=text size=$hor_size name=$nom_chp_form value=\"".$$nom_chp_form."\" ";
				$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
				$code_form .= ">";
				if ($oblig_chp_cour=="true"){
					$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
				   	$code_form .= "&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=3>*</font>\n";
	 				$oblig_chp_cour="false";
	 			
				}
				$code_form .= "</td>";
			}
		}
		
		// Cas d'un champ de type textarea.
		if ($field_type=="textarea" || $field_type=="web"){
			// On incrmente le compteur de champ du formulaire.
			$compt_elem_form++;
			// On crit le champ de type textarea en appelant la fonction construireContrJs pour l'appel du contrle javascript associ  ce champ (voir plus bas dans ce script pour les dtails sur cette fonction).
			// La variable compt_textarea contient le code HTML du champ en lecture seule o est affich le nombre de caractres restants  saisir dans le champ textarea.
			global $nb_keywords;
			$code_form .= " <td valigne='middle'><textarea class=vertic cols=$hor_size rows=$vert_size name=$nom_chp_form onFocus=\"HideAllDiv();\"";
			$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
			$code_form .= ">".$$nom_chp_form."</textarea>".$compt_textarea;
			
			
			// Si la saisie de la valeur est obligatoire, on ajoute le champ dans la liste des valeurs obligatoires.
			if ($oblig_chp_cour=="true"){
				$liste_chp_oblig["$nom_chp_form"] = $compt_elem_form;
			 	//$code_form .= "&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=1>*</font>\n";
	 		}
			// On incrmente encore le compteur de champ du formulaire  cause de l'ajout du champ en lecture seule qui contient le nombre de caractres max restants  saisir dans le textarea.
			$compt_elem_form++;
			$code_form .= "</td>";
		}

		// Cas d'un champ de type select.
		if ($field_type=="select"){
			// On incrmente le compteur de champ du formulaire.
			$compt_elem_form++;
			// On crit le champ de type select en appelant la fonction construireContrJs pour l'appel du contrle javascript associ  ce champ (voir plus bas dans ce script pour les dtails sur cette fonction).
			$code_form .= " <td valign='middle'><select name=$nom_chp_form";
			$code_form .= construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem_cour);
			$code_form .= ">\n";
			// Il faut remplir la liste droulante avec les options dfinies dans la norme comme faisant parti de cette liste (table elmnt_code_list).
			$req_item = "SELECT elmnt_id, elmnt_code" .
					" FROM elmnt_code_list" .
					" WHERE list_short_name='$list_short_name'" .
					" ORDER BY elmnt_code ASC";
			
			$res_item = $connection->Execute("$req_item");
			while ($ligne_item = $res_item->FetchRow()){
			 	
			 	// Identifiant de l'lment de la liste.
				$elmnt_id_cour = $ligne_item["elmnt_id"];
				// Code  transmettre pour cet lment de la liste.
				$elmnt_code_cour = $ligne_item["elmnt_code"];
				// Libell de cet lment de la liste.
				$item_lbl_cour = labelLang($elmnt_id_cour,"elmnt_code_list",$la,"label_stand");
				// Ajout de l'lment dans la liste.
				$code_form .= "<option value='$elmnt_code_cour'";
				if ($elmnt_code_cour==$$nom_chp_form){
					$code_form .= " selected";
				}
				$code_form .= ">".ucfirst($item_lbl_cour)."</option>\n"; 
			}
			// Fermeture de la liste.
			$code_form .= "</select></td>\n";
		}
	 	// Si la saisie de la valeur est obligatoire, on affiche une coche rouge en face de la liste.
	 	// Pas besoin d'ajouter le champ dans la liste des contrles pour les valeurs obligatoires car pour un select il y a forcment toujours une option slectionne.
	}
	 // Saut de ligne dans le formulaire.
		//if (!$firstPrint){
			if ($oblig_chp_cour=="true"){
				$code_form .= "<td valign'=middle'>&nbsp;&nbsp;&nbsp;<font color='red' face='Verdana' size=3>*</font></td>\n";
			}
			$code_form.="</tr></table>";
			//$code_form .= "<br>\n";
		//}else{
		//	$code_form.="</tr></table>";
		//}
	}

// --------------- FIN DE LA FONCTION ecrireElemForm -------------------------


// ------------------ DEBUT DE LA FONCTION construireContrJs -----------------------
// Cette fonction crit l'appel vers le (ou les) contrle(s) javascript associs au champ de saisie pass en paramtre.
/* Paramtres : 
* identifiant de l'lment associ au champ dans la norme
* indice du champ que l'on veut afficher dans la hirarchie du formulaire
* identifiant du champ de saisie
* type du champ de saisie
* intitul de l'lment associ au champ dans la langue choisie par l'utilisateur
*/

function construireContrJs($id_elmnt,$suffixe,$field_id,$field_type,$intit_elem){
	global $connection; // connection vers la base
	global $gab_name; // nom du gabarit
	global $code_form; // variable dans laquelle on crit le code du formulaire
	global $compt_elem_form; // compteur des champs du formulaire
	global $la; // langue choisie par l'utilisateur
	global $lang; // langue franaise ou anglaise (utilise dans l'affichage du calendrier pour la saisie d'une date)
	global $url_site; // URL du site pour le chemin d'accs aux fichiers inclus
	global $alias_appli; // nom de l'appli pour complter le chemin prcdent
	global $compt_textarea; // variable utilise pour le code HTML du compteur spcifique aux champs de type textarea
	$compt_textarea="";

	// Initialisation de la valeur retourne par la fonction.
	$ret = "";
	// Rcupration des caractristiques du contrle associ au champ.
	$req_contr = "SELECT nom_control, event_js, ordre_control" .
			" FROM field_control" .
			" WHERE field_id='$field_id'" .
			" ORDER BY ordre_control ASC";
	$res_contr = $connection->Execute("$req_contr");
	while ($ligne_contr = $res_contr->FetchRow()){
		// Nom du contrle (nom de la fonction javascript qui le gre).
		$nom_control = $ligne_contr["nom_control"];
		// Evnement qui dclenche le code javascript du contrle.
		$event_js = $ligne_contr["event_js"];
		// Numro d'ordre du contrle (utile dans le cas des champs qui en possdent plusieurs).
		$ordre_control = $ligne_contr["ordre_control"];
		
		// ------------------------------------------------------------------------------------------------
		// Dans le reste du code de cette fonction, on va maintenant traiter l'criture de l'appel vers les contrles javascript (en fonction du nom du contrle ou de l'vnement qui dclenchera le contrle).

		// On n'appelle pas la fonction de vrification des dates si le champ associ n'est pas de type text (cas des champs date en lecture seule).
		if ($nom_control == "verifDate" && $field_type != "text"){ return $ret; }
		
		// On ajoute le dclencheur dans l'appel.
		$ret .= $event_js."=\"";
		// On initialise le boolen d'affichage de l'appel.
		$bool_contr=true;
		
		// Cas du contrle pour la longueur max d'un textarea, avec affichage d'un compteur du nombre de caractres restants (fonction javascript maxCar).
		if ($nom_control == "maxCar"){
			// On rcupre le nom du champ textarea.
			$nom_chp = $id_elmnt."_".$suffixe;
			// Nom pour l'adressage javascript du champ textarea.
			$chp_source = "form0.elements[".$compt_elem_form."]";
			// Nom pour l'adressage javascript du compteur associ au champ textarea.
			$compt_elem_suiv=$compt_elem_form+1;
			$chp_compt = "form0.elements[".$compt_elem_suiv."]";
			
			// Ecriture de l'appel du contrle javascript pour un textarea, on rcupre le paramtre  envoyer  la fonction javascript depuis la table param_control de la base (dans ce cas il n'y qu'un seul paramtre).
			// On y ajoute un appel  la fonction decoupCar charg de couper le texte au nombre de caractres max si l'utilisateur venait  dpasser cette valeur.
			$ret .= "return ".$nom_control."(this,$chp_compt,";
			$req_param = "SELECT val_param FROM param_control WHERE field_id='$field_id' AND ordre_control='$ordre_control'
						  ORDER BY ordre_param ASC";
			$res_param = $connection->Execute("$req_param");
			$ligne_param = $res_param->FetchRow();
			$param = $ligne_param["val_param"];
			$intit_aff = addslashes($intit_elem);
			$ret .= "'".$param."',event);\" onBlur=\"decoupCar(this,$chp_compt,'".$param."','".$intit_aff."');\"";
			
			// Nom du champ compteur associ au textarea.
			$tmp = "c".$suffixe;
			// On rcupre la valeur prcdente du compteur (avant rechargement du formulaire).
			global $$tmp;
			// Rcupration du label pour le texte situ  droite du compteur ("restants" en franais).
			$lbl_restants = labelLang("restants","message_interface",$la,"label");
			// Mmorisation du code HTML pour l'criture du champ en lecture seule contenant le compteur (ajout au code du formulaire dans la fonction ecrireElemForm pour le cas d'un textarea).
			$compt_textarea = " &nbsp;<input readonly name='c".$suffixe."' class=readonly onFocus=this.blur() size=2 value='".$$tmp."'><font face=Arial size=2><b> $lbl_restants</b></font>";
			// L'appel  la fonction javascript a t gnr, on passe le boolen de contrle d'affichage  false.
			$bool_contr=false;
		}
		
		// Cas d'un contrle dclench par un vnement onKeyPress ou onKeyDown (en excluant le cas de la fonction javascript maxCar qui prcde).
		if ($bool_contr && ($event_js=="onKeyPress" || $event_js=="onKeyDown")){
			$ret .= "return ".$nom_control."(event);\""; $bool_contr=false;
		}
		
		// Traitement de tous les autres cas.
		if ($bool_contr){
			// On rcupre le nom du champ de saisie du formulaire.
			$nom_chp = $id_elmnt."_".$suffixe;
			// Ecriture de l'appel du contrle javascript, on rcupre les paramtres  envoyer  la fonction javascript depuis la table param_control de la base (dans ce cas il peut y avoir plusieurs paramtres).
			$ret .= $nom_control."(this.form,'$nom_chp',";
			$req_param = "SELECT val_param FROM param_control WHERE field_id='$field_id' AND ordre_control='$ordre_control'
						  ORDER BY ordre_param ASC";
			$res_param = $connection->Execute("$req_param");
			while ($ligne_param = $res_param->FetchRow()){
				$param = $ligne_param["val_param"];
				$ret .= "'".$param."',";	
			}
			$ret .= "'".$intit_elem."');\"";
			
			// Dans le cas particulier de la fonction verifDate pour la vrification du format des dates, on ajoute un bouton avec un appel vers la fonction saisDate qui permet d'ouvrir une fentre avec un calendrier.
			
			if ($nom_control == "verifDate" && $field_type == "text"){
				global $lang;
				$annee_cour = date("Y");
				$ret .= "> <a name=date_$suffixe href='#date_$suffixe' onClick=\"saisDate('form0','".$nom_chp."','1900','$annee_cour','$lang')\">";
				$ret .= "<img border=0 align=absmiddle src='".$url_site.$alias_appli."img/calendrier.gif'></a";
			}
		}
	}
	// On retourne l'appel vers les fonctions javascript que l'on vient de gnrer.
	return $ret;
}
// --------------- FIN DE LA FONCTION construireContrJs -------------------------
// ------------------------------------------------------------------------------
// Construction de la fonction de contrle javascript pour la vrification de la saisie des champs obligatoires.

$mess_oblig = labelLang("erreur_saisie_oblig","message_interface",$la);
$code_javascript = "<script language='Javascript'>\n";
$code_javascript .= "\nfunction verifOblig(formul)\n";
$code_javascript .= "{\n";

if (count($liste_chp_oblig)!=0){
	// Pour chacun des champs entr dans le tableau $liste_chp_oblig, on teste si la valeur saisie est nulle.
	// Si c'est le cas, on renvoie un message d'erreur avec l'intitul du champ et on empche la validation du formulaire en retournant false.
	foreach ($liste_chp_oblig as $nom_chp=>$val){
			// On supprime l'indice en suffixe pour rcuprer l'identifiant de l'lment de mtadonne dans la norme.
			ereg ("^(.*)_[0-9a-zA-Z]+$",$nom_chp,$corresp);
			// On charge l'intitul de l'lment.
			$intit_cour = labelLang($corresp[1],"elmnt_mtd",$la,"label_stand");
			// On crit le code de la fonction de contrle javascript.
			$code_javascript .= "if (formul.elements[".$val."].value==\"\")\n"; 
			$code_javascript .= "{ alert(\"".$mess_oblig." '".$intit_cour."'.\");\n";
			$code_javascript .= "  return false; }\n";
	}
}
// Tout s'est bien pass, on valide le formulaire en retournant true.
$code_javascript .=  "return true;\n";
$code_javascript .=  "}\n";

// Ecriture du formulaire de saisie.
echo $code_javascript;
echo "</script>";
echo "<script type=\"text/javascript\" src=\"ajax.js\"></script>\n";

echo $code_corps;
echo $code_form;
echo $code_ancre;
?>
</td></tr></table>
</body>
</html>
