<?php
/**
 *  Script de traitement pour l'importation d'une fiche XML.
 *
 **/

// Inclusion du script de configuration et de paramtrage de l'appli.
require_once("../config/config.inc.php");
// Inclusion de la bibliothque de fonctions.
require_once $chemin_appli."config/fonctions.inc.php";
// Inclusion de la bibliothque de fonctions de l'interface utilisateur (pour la fonction indConversion).
require_once $chemin_appli."users/inc/fonctions.inc.php";
require_once $chemin_appli."classes/GestionnaireGabarit.php";
// Chargement des labels affichs sur la page.
$import_xml = labelLang("import_xml","message_interface",$la,"label");
$erreur_analyse_xml = labelLang("erreur_analyse_xml","message_interface",$la,"label");
$aucune_fiche_import = labelLang("aucune_fiche_import","message_interface",$la,"label");
$mess_confirm_import = labelLang("mess_confirm_import","message_interface",$la,"label");
$mess_autres_fiches_import = labelLang("mess_autres_fiches_import","message_interface",$la,"label");

// Rcupration de la politique de publication pour dterminer
// le mtd_nivacces et est_validee par dfaut des fiches.
$polit_publi = politPubli();
if($polit_publi == 0){
	$mtd_nivacces = 3;
	$est_valid="true";
}else{
	$mtd_nivacces = 1;
	$est_valid="false";
}
?>
<html>
<!-- date de creation: 09/09/2004 -->
<head>
<?php echo "<title>$import_xml</title>"; ?>
<meta name="Description" content="">
<meta name="Keywords" content="">
<meta name="Author" content="Nicolas Moyroud">
<meta http-equiv="Content-Type" content="text/html; charset='iso-8859-1'">
<?php

?>
</head>
<body>
<?php

unset($liste_fiches_import);
for ($compt_fiches = 0; $compt_fiches < count($id_fiche); $compt_fiches++) {
	if ($bool_import[$compt_fiches] == "update" || $bool_import[$compt_fiches] == "create") {
		$liste_fiches_import[] = $id_fiche[$compt_fiches];
		// Ouverture du document XML.
		if (!$xmldoc = domxml_open_file($chemin_appli."xml/import/".$id_fiche[$compt_fiches])) {
			echo $erreur_analyse_xml."\n";
			exit;
		};
		$code_observatoire = $code_observatoire_trans[$compt_fiches];
		
		$code_observatoire_xml=$code_observatoire_trans_xml[$compt_fiches];
		
		if($bool_import[$compt_fiches] == "create"){
			$req2 = "SELECT MAX(mtd_sheet_id) AS mtd_sheet_id_max" .
					" FROM mtd_form" .
					" WHERE code_observatoire='$code_observatoire'";
			$res2 = $connection->Execute($req2);
			if ($res2 && $res2->RecordCount() != 0) {
				$ligne2 = $res2->FetchRow();
				$mtd_sheet_id = $ligne2['mtd_sheet_id_max']+1;
			}
		}else{
			$mtd_sheet_id = $mtd_sheet_id_trans[$compt_fiches];
		}
		$source_import = $source_import_trans[$compt_fiches];
		$update_date = $update_date_trans[$compt_fiches];
	
	// Rcupration de la racine du document.
	$rootNode = $xmldoc->document_element();
	// Dtermination du gabarit associ  la fiche.
	$docType = $xmldoc->doctype();
	preg_match("|/xml/dtd/roselt_([^\.]+)\.dtd$|",$docType->system_id(),$corresp);
	//preg_match("|/xml/dtd/([^\.]+)\.dtd$|",$docType->system_id(),$corresp);
	$gabarit_name = $corresp[1];
	//echo 'gabarit_name = '.$gabarit_name.'<br>';
	
	//CAP VERT
	if ($source_import=="MDweb" && preg_match("|^title_(.*)_title_([a-zA-Z]+_[a-zA-Z]{2})_([0-9]+)_([0-9]{4}-[0-9]{2}-[0-9]{2})\.xml$|",$id_fiche[$compt_fiches],$corresp)){
		$titre_fiche=$corresp[1];
	}elseif($source_import=="MDweb"){
		$titre_fiche = recup_valeur_speciale($rootNode,"Metadata","mdFileID");
		$titre_fiche=str_replace("MDWeb_","",$titre_fiche);
	
	}else{
		// Rcupration du titre (identifiant) de la fiche dans le document XML.
		$titre_fiche = recup_valeur_speciale($rootNode,"Metadata","mdFileID");
		$titre_fiche=str_replace("ArcGis_","",$titre_fiche);
		$titre_fiche=str_replace($code_observatoire."_","",$titre_fiche);
		//AJOUTER ICI LE PROBLEME DE CARACTERES
		$titre_fiche=utf8_decode($titre_fiche);
		
	}
	
	// Recherche de la valeur de elmnt_mtd_id pour l'lment racine de ce gabarit.
	$req = "SELECT elmnt_mtd.elmnt_mtd_id FROM elmnt_mtd,elmnt_gabarit" .
			" WHERE elmnt_gabarit.elmnt_mtd_id=elmnt_mtd.elmnt_mtd_id" .
			" AND data_type_code='racine'" .
			" AND gabarit_name='$gabarit_name'";
	$res = $connection->Execute($req);
	$ligne = $res->FetchRow();
	$racine_mtd_id = $ligne['elmnt_mtd_id'];
	
	//$childnodes = $rootnode->child_nodes();
	unset ($tab_num_elmnt);
	calcul_base_num_elmnt($racine_mtd_id);
	
	//$num_elmnt = subst_num_elmnt("50000","0001");
	//echo "num_elmnt = $num_elmnt<br><br>";
	
	$req = "DELETE FROM mtd_value" .
			" WHERE mtd_sheet_id='$mtd_sheet_id'" .
			" AND code_observatoire='$code_observatoire'";
	$connection->Execute($req);
	
	
	$req = "DELETE FROM niv_form" .
			" WHERE mtd_sheet_id='$mtd_sheet_id'" .
			" AND code_observatoire='$code_observatoire'";
	$connection->Execute($req);
	$req = "DELETE FROM import_form" .
			" WHERE mtd_sheet_id='$mtd_sheet_id'" .
			" AND code_observatoire='$code_observatoire'";
	$connection->Execute($req);
	
	// Insertion de la fiche dans la table mtd_form. Si la fiche existe dj il faut la mettre  jour sans l'effacer
	// car sinon on dtruirait galement la rfrence  cette fiche dans les tables archive_zip et fichier_ressource.
	$req_select = "SELECT gabarit_name" .
			" FROM mtd_form" .
			" WHERE mtd_sheet_id='$mtd_sheet_id'" .
			" AND code_observatoire='$code_observatoire'";
	$res_select = $connection->Execute($req_select);
	//HERE
	//ICI
	if ($res_select && ($res_select->RecordCount() > 0)) {
		$req = "UPDATE mtd_form" .
				" SET titre_fiche='$titre_fiche'," .
				" login_sais='$nomUtil'," .
				" login_val=NULL," .
				" gabarit_name='$gabarit_name',
					mtd_nivacces='$mtd_nivacces'," .
					" update_date='$update_date'" .
					" WHERE mtd_sheet_id='$mtd_sheet_id'" .
					" AND code_observatoire='$code_observatoire'";
		$connection->Execute($req);
	}else{
		$req = "INSERT INTO mtd_form (mtd_sheet_id," .
				" code_observatoire," .
				" titre_fiche," .
				" login_sais," .
				" login_val," .
				" gabarit_name," .
				" mtd_nivacces," .
				" update_date)
		  		VALUES ('$mtd_sheet_id'," .
			  "'$code_observatoire'," .
			  "'$titre_fiche'," .
			  "'$nomUtil'," .
			  "NULL," .
			  "'$gabarit_name'," .
			  "'$mtd_nivacces'," .
			  "'$update_date')";
		$connection->Execute($req);
	}				
	
	// Insertion des informations d'importation de la fiche dans la table import_form.
	$req = "INSERT INTO import_form(code_observatoire," .
			"mtd_sheet_id," .
			"source_import," .
			"fichier_xml," .
			"import_date)" .
			" VALUES ('$code_observatoire'," .
			"'$mtd_sheet_id'," .
			"'$source_import'," .
			"'".$id_fiche[$compt_fiches]."'," .
			"'$update_date')";
	$connection->Execute($req);
	
	// Initialisation du parcours du document XML  partir du noeud racine.
	parcoursXML($rootNode);
	chercheRubriquesMultiple($mtd_sheet_id,$code_observatoire,$gabarit_name);
	if ($source_import != "MDweb") {
		majFiliation($rootNode);
	}
	if ($code_observatoire!=$code_observatoire_xml){
		$select="SELECT mtd_value FROM mtd_value" .
				" WHERE mtd_sheet_id='$mtd_sheet_id'" .
				" AND code_observatoire='$code_observatoire'" .
				" AND elmnt_mtd_id='fileIdentifier_2'";
		$res=$connection->Execute($select);
		
		while($ligne=$res->FetchRow()){
			$mtd_value=str_replace($code_observatoire_xml,$code_observatoire,$ligne['mtd_value']);
			$update="UPDATE mtd_value" .
				" SET mtd_value='$mtd_value'" .
				" WHERE mtd_sheet_id='$mtd_sheet_id'" .
				" AND code_observatoire='$code_observatoire'" .
				" AND elmnt_mtd_id='fileIdentifier_2'";
			$connection->Execute($update);
		}
	}
	
	
	
	// Recherche du niveau de saisie complet le plus lev puis insertion de chaque niveau dans la table niv_form.
	$saisie_complete = array("false","false","false");
	for ($i=0;$i<3;$i++) {
		if(estCompletNiveauSaisie($mtd_sheet_id,$code_observatoire,$gabarit_name,$i)) {
			$saisie_complete[$i]="true";
		}else { break; }
	}
	if ($saisie_complete[2]=="true") {$default_niv_saisie=3;}
	elseif ($saisie_complete[1]=="true"){$default_niv_saisie=2;}
	else {$default_niv_saisie=0;}
	$req = "INSERT INTO niv_form" .
			" VALUES ('$mtd_sheet_id'," .
			"'$code_observatoire'," .
			"'0'," .
			"'$saisie_complete[0]'," .
			"'$est_valid'," .
			"''," .
			"'$default_niv_saisie')";
	$connection->Execute($req);
	
	$req = "INSERT INTO niv_form" .
			" VALUES ('$mtd_sheet_id'," .
			"'$code_observatoire'," .
			"'1'," .
			"'$saisie_complete[1]'," .
			"'$est_valid'," .
			"''," .
			"'$default_niv_saisie')";
	$connection->Execute($req);
	
	$req = "INSERT INTO niv_form" .
			" VALUES ('$mtd_sheet_id'," .
			"'$code_observatoire'," .
			"'2'," .
			"'$saisie_complete[2]'," .
			"'$est_valid'," .
			"''," .
			"'$default_niv_saisie')";
	$connection->Execute($req);
	} // fin du if ($bool_import[$compt_fiches] == "true")

	//traitement des imagettes
	if ($fichier_name[$compt_fiches]!="" && $fichier_name[$compt_fiches]!="/"){
		include_once $chemin_appli."admin/inc/images/import_image_traitement.inc.php";
		insertImageBase($mtd_sheet_id, $code_observatoire,$gabarit_name,$rep_imagettes, $fichier_name[$compt_fiches], $format_name[$compt_fiches], $description_fichier[$compt_fiches]);
	
	}
	//traitement des zip (ressources)
	//A COMPLETER
	if ($ress_name[$compt_fiches]!="" && $ress_name[$compt_fiches]!="/"){
		include_once $chemin_appli."admin/inc/import_xml/import_ressource_traitement.inc.php";
		insertRessourceBase($mtd_sheet_id, $code_observatoire,$gabarit_name,$rep_ressources, $ress_name[$compt_fiches], $ress_format[$compt_fiches],$ress_size[$compt_fiches]);
	}

} // fin du for ($compt_fiches = 0; $compt_fiches < count($id_fiche); $compt_fiches++)

//destruction des fichiers zip ressources
for ($compt_fiches = 0; $compt_fiches < count($id_fiche); $compt_fiches++){
	if ($ress_name[$compt_fiches]!="" && $ress_name[$compt_fiches]!="/"){
		if(file_exists($rep_ressources.$ress_name[$compt_fiches])){
			unlink($rep_ressources.$ress_name[$compt_fiches]);
		}
	}
}



//*************************************
//****TRAITEMENT des fiches parentes et des filles***
//*************************************


// 1er cas : cas import arcGis

//cas importation d'une godatabase
function majFiliation($rootNode){
	global $gabarit_name;
	global $code_observatoire;
	global $source_import;
	global $titre_fiche;
	global $connection;
	global $mtd_sheet_id;
	
	if ($gabarit_name=="base_geo") {
		
		
		//recherche identifiant (mdFileID)
		$idFiche=recup_element($rootNode,"mdFileID");
		
		//recherche toutes les fiches filles dans mtd_value ayant cet idfiche comme parent (pour mme observatoire
				
		$req = "SELECT mtd_sheet_id" .
				" FROM mtd_value" .
				" WHERE elmnt_mtd_id='parentIdentifier_5'" .
				" AND mtd_value='$idFiche'" .
				" AND code_observatoire='$code_observatoire'";
		
		$res = $connection->Execute($req);
		while ($ligne = $res->FetchRow()){
			
			$fils_fiche_id=$ligne['mtd_sheet_id'];
			
			//insertion dans table a pour parent du lien de parent si il n'existe pas
			$req2 = "SELECT *" .
					" FROM a_pour_parent" .
					" WHERE code_observatoire='$code_observatoire'" .
					" AND fils_sheet_id='$fils_fiche_id'" .
					" AND pere_sheet_id='$mtd_sheet_id'";
			$res2 = $connection->Execute($req2);
			if (!$res2 || $res2->RecordCount() == 0) {
				$req3 = "INSERT INTO a_pour_parent" .
						" VALUES ('$code_observatoire','$fils_fiche_id','$mtd_sheet_id')";
				$connection->Execute($req3);
			}
		}
	
	}
	//cas vecteur ou table numrique ayant un idparent (appartient geodatabase)
	elseif($gabarit_name=="couche_vecteur" || $gabarit_name=="table_num"){
		
		$idParent=recup_element($rootNode,"mdParentID");
		if ($idParent!="") {
				
				
							
				//recherche dans mdweb la fiche parente pour cet observatoire si elle existe
				
				$req = "SELECT mtd_sheet_id" .
						" FROM mtd_value 
					WHERE elmnt_mtd_id='fileIdentifier_2'" .
							" AND mtd_value='$idParent'" .
							" AND code_observatoire='$code_observatoire'";
				$res = $connection->Execute($req);
				
				// la fiche parente existe
				if ($res && $res->RecordCount() != 0) {
					
					$ligne=$res->FetchRow();
					//rcupration de l'identifiant MDWeb de cette fiche
					$fiche_parente=$ligne['mtd_sheet_id'];
					//recherche du lien de parent dans a pour parent
					$req2 = "SELECT * FROM a_pour_parent" .
							" WHERE code_observatoire='$code_observatoire'" .
							" AND fils_sheet_id='$mtd_sheet_id'" .
							" AND pere_sheet_id='$fiche_parente'";
					$res2 = $connection->Execute($req2);
					//si lien de parent existe pas
					if (!$res2 || $res2->RecordCount() == 0) {
				    	$req3 = "INSERT INTO a_pour_parent VALUES ('$code_observatoire','$mtd_sheet_id','$fiche_parente')";
						
						$connection->Execute($req3);
					}			
					
					
				}
		
				//associer  cette fiche, la fiche parente trouve (si elle existe) dans table a pour parent
		}
	}


}
//FIN TRAITEMENT FICHE PARENTE



// Cas o il ne restait aucune fiche XML  importer.
if (!isset($liste_fiches_import)) {
	echo '<div class="mess_erreur_saisie">'.$aucune_fiche_import.'</div>';
}else{
	for ($i = 0, $liste_fiches_aff = ''; $i < count($liste_fiches_import); $i++){
		$liste_fiches_aff .= stripslashes($liste_fiches_import[$i])."<br>";
	}
	//$liste_fiches_aff = substr($liste_fiches_aff,0,-2);
	echo '<div class="mess_confirm_envoi">'.$mess_confirm_import.'</div><br />';
	echo '<center><b><p>'.$liste_fiches_aff.'</p></b></center>';
}
echo '<div class="center">';
echo '<form name="autres_fiches" action="index.php?script=import_export&action=import_xml" method="POST">'."\n";
echo '<input class="envoi_'.$theme.'" type="submit" value="'.$mess_autres_fiches_import.'">'."\n";
echo '</form></div>'."\n";

// Fonction pour la rcupration de la valeur d'un lment donn dans le document XML.
function recup_valeur_speciale($rootNode,$parentName,$elmntName) {
	$parentNodes = $rootNode->get_elements_by_tagname($parentName);
	$titleNodes = $parentNodes[0]->get_elements_by_tagname($elmntName);
	$elmntValue = $titleNodes[0]->get_content();
	return $elmntValue;
}


//fonction de recherche d'un lement spcifique
function recup_element($rootNode,$nameElement) {
		if($rootNode != null && $rootNode->node_type() == XML_ELEMENT_NODE){
		//$nodes = $rootNode->get_elements_by_tagname("Metadata");
		$elements=$rootNode->child_nodes();
		foreach ($elements as $childNode) {
			if(!$childNode->is_blank_node() && isset($childNode)) {
					if ($childNode->node_name()==$nameElement) {
						$childChildNodes = $childNode->child_nodes();
						foreach ($childChildNodes as $childChildNode){
							if ($childChildNode->node_type() == XML_TEXT_NODE && $childChildNode->node_value() != '' && !$childChildNode->is_blank_node()){
								return ($childChildNode->node_value());
								//exit;
					 		}
						}
					}
					$return=recup_element($childNode,$nameElement);
					if ($return) {
						return $return;					    
					}
			}
		}
	}
	return false;
}


// Fonction de parcours du document XML pour l'importation dans la base de donnes.
function parcoursXML($parentNode,$indice_subst="") {
	global $connection;
	global $tab_num_elmnt;
	global $gabarit_name;
	global $mtd_sheet_id;
	global $code_observatoire;
	global $source_import;
	if($parentNode != null && $parentNode->node_type() == XML_ELEMENT_NODE) {
		$childNodes = $parentNode->child_nodes();
		foreach ($childNodes as $childNode) {
			if(!$childNode->is_blank_node()) {
				$childChildNode = $childNode->first_child();
				if(isset($childChildNode)) {
					$value = $childChildNode->get_content();
					while($childChildNode->is_blank_node()) {
						$childChildNode = $childChildNode->next_sibling();
					}
					if($childChildNode->node_type() != XML_TEXT_NODE && !$childChildNode->has_attributes()) {
						//if ($childNode->node_name() != "geoEle" && $childNode->node_name() != "TM_GeometricPrimitive"){
						if ($childNode->node_name() != "TM_GeometricPrimitive"){
						
							$elmnt_mtd_id = calcul_elmnt_mtd_id($childNode);
							$num_elmnt = $tab_num_elmnt[$elmnt_mtd_id];
							if ($frere_id[$elmnt_mtd_id] != "") {
								$indice_subst_cour = $indice_subst."0".indConversion($frere_id[$elmnt_mtd_id]);
							}else {
								$indice_subst_cour = $indice_subst."00";
							}
							$frere_id[$elmnt_mtd_id] += 1;
						}
						parcoursXML($childNode,$indice_subst_cour);
					}else {
						$childChildNodes = $childNode->child_nodes();
						foreach ($childChildNodes as $childChildNode) {
							$mtd_value="";
							if ($childChildNode->has_attributes() && !$childChildNode->is_blank_node()) {
								$mtd_value = $childChildNode->get_attribute("value");
								$type = "liste";
							}elseif ($childChildNode->node_type() == XML_TEXT_NODE && $childChildNode->node_value() != '' && !$childChildNode->is_blank_node()) {
								$mtd_value = $childChildNode->node_value();
								$type = "simple";
							}else {
								$type="continue";
								continue;
							}
							if ($mtd_value != "") {
								$elmnt_mtd_id = calcul_elmnt_mtd_id($childNode);
								if ($elmnt_mtd_id != "erreur elmnt_mtd_id") {
									if ($frere_id[$elmnt_mtd_id] != "") {
										$num_elmnt = substr($tab_num_elmnt[$elmnt_mtd_id],0,-1).indConversion($frere_id[$elmnt_mtd_id]);
									}else {
										$num_elmnt = $tab_num_elmnt[$elmnt_mtd_id];
									}
									$num_elmnt = subst_num_elmnt($num_elmnt,$indice_subst);
									$mtd_value = utf8_decode($mtd_value);
									if ($db_type != "mysql") {
										$mtd_value = substr($mtd_value,0,500);
									}
									$mtd_value = addslashes($mtd_value);
									$req = "INSERT INTO mtd_value" .
											" VALUES ('$mtd_sheet_id','$code_observatoire','$gabarit_name','$elmnt_mtd_id','$num_elmnt','$mtd_value')";
									$connection->Execute($req);
									$frere_id[$elmnt_mtd_id] += 1;
								}
							}
						}
					}
				} // fin du if(isset($childChildNode))
			}
		}
	}
}

// Fonction qui sert  dterminer la valeur du elmnt_mtd_id d'un lment du gabarit  partir de son short_name.
function calcul_elmnt_mtd_id($currentNode){
	global $connection;
	global $gabarit_name;
	$elmnt_short_name = $currentNode->node_name();
	
	
	$req = "SELECT elmnt_mtd.elmnt_mtd_id FROM elmnt_gabarit,elmnt_mtd
			WHERE elmnt_gabarit.elmnt_mtd_id=elmnt_mtd.elmnt_mtd_id
				AND gabarit_name='$gabarit_name' AND elmnt_short_name='$elmnt_short_name'";
	
	$res = $connection->Execute("$req");
	$nb_res = $res->RecordCount();
	// Si le elmnt_mtd_id est dtermin de faon unique, on le renvoie directement.
	
	if ($nb_res == 1) {
		$ligne = $res->FetchRow();
		
		return $ligne['elmnt_mtd_id'];
	}
	// Si le short_name correspond  plusieurs elmnt_mtd_id pour ce gabarit,
	// on appelle la fonction de traitement spcifique sur un tableau contenant les candidats possibles.
	else {
		while($ligne = $res->FetchRow()){
			
			$liste_mtd_id[] = $ligne['elmnt_mtd_id'];
		}
		return separ_mult_mtd_id($liste_mtd_id,$currentNode);
	}
}

// Fonction charge de dterminer l'elmnt_mtd_id rel d'un lment de gabarit si son short_name correspond  plusieurs.
function separ_mult_mtd_id($liste_mtd_id,$currentNode) {
	// Parcours des elmnt_mtd_id possibles contenus dans le tableau $liste_mtd_id.
	// Ds qu'on aura trouv le bon, la boucle sera stoppe par l'instruction return.
	if ( is_array($liste_mtd_id) && count($liste_mtd_id) > 0 ) {
		foreach ($liste_mtd_id as $elmnt_mtd_id) {
			if (recurs_mult_mtd_id($elmnt_mtd_id,$currentNode)) {
				return $elmnt_mtd_id;
			}
		}
	}
	return "erreur elmnt_mtd_id"; // Ne doit jamais se produire.
}

// Fonction rcursive utilise par la prcdente pour la dtermination de l'elmnt_mtd_id rel parmi plusieurs.
function recurs_mult_mtd_id($elmnt_mtd_id,$currentNode) {
	global $connection;
	global $gabarit_name;
	global $racine_mtd_id;
	// On passe au noeud parent pour rcuprer le short_name issu du document XML.
	$parentNode = $currentNode->parent_node();
	$parent_short_name_xml = $parentNode->node_name();
	
	// Traitement du cas particulier pour le geoBndBox : on saute un niveau pour prendre le parent du parent.
	if ($parent_short_name_xml == "GeoBndBox" || $parent_short_name_xml == "geoBndBox" || $parent_short_name_xml == "GeoDesc" || $parent_short_name_xml == "geoDesc" ||$parent_short_name_xml == "boundPoly") {
		$parentNode = $parentNode->parent_node();
		$parent_short_name_xml = $parentNode->node_name();
	}
	// Traitement du cas particulier pour le TM_Period : on saute deux niveaux pour prendre le parent du parent du parent.
	if ($parent_short_name_xml == "TM_Period") {
		$parentNode = $parentNode->parent_node();
		$parentNode = $parentNode->parent_node();
		$parent_short_name_xml = $parentNode->node_name();
	}
	
	
	// Rcupration du short_name du parent issu de la base de donnes.
	$req = "SELECT elmnt_pere_id,elmnt_short_name,data_type_code FROM est_contenu,elmnt_mtd
			WHERE est_contenu.elmnt_pere_id=elmnt_mtd.elmnt_mtd_id AND est_contenu.gabarit_name='$gabarit_name'
				AND est_contenu.elmnt_fils_id='$elmnt_mtd_id'";
	$res = $connection->Execute($req);
	$ligne = $res->FetchRow();
	$parent_elmnt_mtd_id = $ligne['elmnt_pere_id'];
	$parent_short_name_bd = $ligne['elmnt_short_name'];
	$parent_data_type_code = $ligne['data_type_code'];
	
	
	
	// Si le parent est une classe, on saute un niveau pour prendre son short_name.
	if ($parent_data_type_code == "class") {
		$req = "SELECT elmnt_pere_id,elmnt_short_name FROM est_contenu,elmnt_mtd
				WHERE est_contenu.elmnt_pere_id=elmnt_mtd.elmnt_mtd_id AND est_contenu.gabarit_name='$gabarit_name'
				AND est_contenu.elmnt_fils_id='$parent_elmnt_mtd_id'";
		$res = $connection->Execute($req);
		$ligne = $res->FetchRow();
		$parent_elmnt_mtd_id = $ligne['elmnt_pere_id'];
		$parent_short_name_bd = $ligne['elmnt_short_name'];
	}
	// Si le short_name du XML et celui de la base sont les mmes on continue.
	//cas particulier refSySId ( changer dans export MDWeb)
	if ($parent_short_name_xml=="refSysID") {
	    $parent_short_name_xml="refSysId";
	}
	
	if ($parent_short_name_xml == $parent_short_name_bd) {
		// Si on est arriv  la racine du gabarit, c'est qu'on a trouv le bon lment.
		if ($parent_elmnt_mtd_id == $racine_mtd_id) {
			return true;
		}
		// Sinon on continue  chercher au niveau suprieur avec un appel rcursif.
		return recurs_mult_mtd_id($parent_elmnt_mtd_id,$parentNode);
	}
	// Si les short_name trouvs sont diffrents, c'est que l'elmnt_mtd_id de dpart n'tait pas le bon.
	else{
		return false;
	}
}

// Fonction qui sert  dterminer le num_elmnt d'un lment dans un gabarit  partir de son elmnt_mtd_id.
// Ce num_elmnt ne tient pas compte des lments ou rubriques en plusieurs exemplaires si num_occ_gab>1.
function calcul_base_num_elmnt($racine_mtd_id,$indice="") {
	global $connection;
	global $gabarit_name;
	global $tab_num_elmnt;
	$req = "SELECT elmnt_fils_id,ordre,data_type_code,max_occ_gab FROM est_contenu,elmnt_mtd,elmnt_gabarit
			WHERE est_contenu.elmnt_fils_id=elmnt_gabarit.elmnt_mtd_id AND est_contenu.gabarit_name=elmnt_gabarit.gabarit_name
			AND elmnt_gabarit.elmnt_mtd_id=elmnt_mtd.elmnt_mtd_id
			AND elmnt_pere_id = '$racine_mtd_id' AND elmnt_gabarit.gabarit_name = '$gabarit_name'
			ORDER BY ordre ASC";
	$res = $connection->Execute($req);
	while($ligne = $res->FetchRow()) {
		$ordre = $ligne['ordre'];
		if ($indice != "") {$ordre = $ordre - 1;}
		$ordre = indConversion($ordre);
		$elmnt_fils_id = $ligne['elmnt_fils_id'];
		$data_type_code = $ligne['data_type_code'];
		$max_occ_gab = $ligne['max_occ_gab'];
		
		
		
				
		
		if ($data_type_code == "class"){
			calcul_base_num_elmnt($elmnt_fils_id,$indice);
		}
		elseif ($data_type_code == "rubrique"){
			$tab_num_elmnt[$elmnt_fils_id] = $indice.$ordre."0";
			//echo 'num_elmnt rubr '.$elmnt_fils_id .' = '.$tab_num_elmnt[$elmnt_fils_id].'<br>';
			calcul_base_num_elmnt($elmnt_fils_id,$indice.$ordre."0");
		}
		elseif ($max_occ_gab > 1){
			$tab_num_elmnt[$elmnt_fils_id] = $indice.$ordre."0";
			//echo 'num_elmnt max>1 '.$elmnt_fils_id .' = '.$tab_num_elmnt[$elmnt_fils_id].'<br>';
		}
		else{
			$tab_num_elmnt[$elmnt_fils_id] = $indice.$ordre;
			//echo 'num_elmnt max<1 '.$elmnt_fils_id .' = '.$tab_num_elmnt[$elmnt_fils_id].'<br>';
		}
		
		
	}
}

// Fonction utilise pour le num_elmnt afin de substituer avec la bonne occurence dans le cas des rubriques multiples.
function subst_num_elmnt($num_elmnt,$indice_subst) {
	for ($i=0;$i<strlen($indice_subst);$i++) {
		$val_cour = substr($indice_subst,$i,1);
		//echo "val_cour = $val_cour <br>";
		if ($val_cour != 0) {
			$num_elmnt = substr_replace($num_elmnt,$val_cour,$i,1);
		}
	}
	return $num_elmnt;
}

function chercheRubriquesMultiple($idFiche, $obs, $gab){
	global $connection;
	//recherche de toutes les rubriques
	$req="SELECT eg.elmnt_mtd_id, eg.num_elmnt_gab" .
			" FROM elmnt_gabarit eg, elmnt_mtd em" .
			" WHERE em.data_type_code='rubrique'" .
			" AND em.elmnt_mtd_id=eg.elmnt_mtd_id" .
			" AND eg.gabarit_name='$gab'";
	$res=$connection->Execute($req);
	while($ligne=$res->FetchRow()){
		$numRub=$ligne['num_elmnt_gab'];
		$rub=$ligne['elmnt_mtd_id'];
		$nbRub=calculNbRubrique($rub, $numRub, $idFiche,$obs);
		if ($nbRub>1){
			$req_insert_rub="INSERT INTO mtd_value(mtd_sheet_id,code_observatoire,gabarit_name,elmnt_mtd_id,num_elmnt,mtd_value)" .
					" VALUES ('$idFiche','$obs','$gab','$rub','$numRub','$nbRub')";
			$connection->Execute($req_insert_rub);
		}
	}
}
function calculNbRubrique($rub,$numRub,$idFiche,$obs){
	global $connection;
	$nbRubriques=0;
	$gestGab=new GestionnaireGabarit();
	for ($i=0;$i<62;$i++){
		$req="SELECT *" .
			" FROM mtd_value" .
			" WHERE num_elmnt LIKE '$numRub%'" .
			" AND mtd_sheet_id='$idFiche'" .
			" AND code_observatoire='$obs'";
		$res=$connection->Execute($req);
		if ($res && $res->RecordCount()!=0){
			$nbRubriques++;
		
		}else{
			break;
		}
		$numRub=$gestGab->indiceSuivant($numRub);
	}
	return $nbRubriques;
}

?>
</body>
</html>
