#! /usr/bin/perl -w
use Net::Z3950::SimpleServer;
use Net::Z3950::OID;
use DBI;
use strict;
my $session = {};
my $z = new Net::Z3950::SimpleServer(
						INIT   =>  "main::init_handler",
						#CLOSE  =>  "main::close_handler",
						SEARCH =>  "main::search_handler",
						#PRESENT=>  \&present_handler,
						#SCAN   =>  \&scan_handler,
						#SCAN   =>  \&scan_handler,
						FETCH  =>  "main::fetch_handler"
						);
$z->launch_server("zServer.pl", @ARGV);
sub init_handler {
	my $args = shift;
    $args->{IMP_ID} = "007";
    $args->{IMP_NAME} = 'Net::Z3950::zServer';
    $args->{IMP_VER} = "3.14159";
    $args->{ERR_CODE} = "0";
    $args->{HANDLE} = $session;
    $session->{record_id} = 0;
    $session->{FIRSTSET} = 0;
    $session->{criteres}->{empco}=0;
    $session->{criteres}->{mo}=0;
}

sub search_handler {
	my $args = shift;
	my $set_id = $args->{SETNAME};
	my $session = $args->{HANDLE};
	my $rpn = $args->{RPN};
    my @database_list = @{ $args->{DATABASES} };
	my $database=join(" ",@database_list);
	$session->{dbh} = DBI -> connect("DBI:Pg:dbname=$database;host=127.0.0.1","postgres","postgres")
	or die "can't open dataSource MDweb: " . $DBI::errstr;
	my $SQLcond = $rpn->{query}->SQLcond();
	my $sqlCount = "SELECT DISTINCT ind.sheet_id , ind.code_observatoire
	 FROM index ind ";
	if($session->{criteres}->{empco} == 1 && $session->{criteres}->{mo} == 1){
		 $sqlCount .= ", mots_cles mo, md_og empco 
		 WHERE ind.sheet_id=empco.sheet_id 
		 AND ind.code_observatoire=empco.code_observatoire 
		 AND ind.sheet_id=mo.sheet_id 
		 AND ind.code_observatoire=mo.code_observatoire 
		 AND mo.sheet_id=empco.sheet_id 
		 AND mo.code_observatoire=empco.code_observatoire 
		 AND ";		
	}elsif ($session->{criteres}->{empco} == 1) {
		 $sqlCount .= ", md_og empco
	 		WHERE ind.sheet_id=empco.sheet_id
	  		AND ind.code_observatoire=empco.code_observatoire
	   		AND ";
	}elsif ($session->{criteres}->{mo} == 1) {
		 $sqlCount .= ", mots_cles mo
	 		WHERE ind.sheet_id=mo.sheet_id
	  		AND ind.code_observatoire=mo.code_observatoire
	   		AND ";
	}
	
	if($session->{criteres}->{mo} == 0 && $session->{criteres}->{empco} == 0){
		$sqlCount .="WHERE ";
	}
	$sqlCount .= "$SQLcond AND ind.private='false'";
	#warn "$sqlCount\n";
	
	my $dbh = $session->{dbh};
	my $sth = $dbh->prepare($sqlCount)    or die "Impossible de prparer $sqlCount: $dbh->errstr\n";
	$args->{HITS}=$sth->execute() or die "Impossible d'excuter $sqlCount: $sth->errstr\n";
	$session->{FIRSTSET} = 0;
	$session->{HITS} = $args->{HITS};
	$session->{keys} = $sth;
	#warn "hits = ".$args->{HITS}."\n";
}


sub fetch_handler {
	my $args = shift;
	my $session = $args->{HANDLE};
	my $set_id = $args->{SETNAME};
	my $offset = $args->{OFFSET};
	if ($session->{HITS} <= $args->{OFFSET}) { $args->{LAST} = 1; }
	else { $args->{LAST} = 0 };
	my $dbh = $session->{dbh};
	my $keys = $session->{keys};
	$args->{REP_FORM} = Net::Z3950::OID::xml;
	$args->{BASENAME} = "MDweb";
	my @key = $keys->fetchrow_array();
	$session->{FIRSTSET}++;
	for(my $i=$session->{FIRSTSET};$i<$args->{OFFSET};$i++){
		@key = $keys->fetchrow_array();
		$session->{FIRSTSET}++;
	}
	fetch_a_record($dbh,@key);
	$args->{RECORD} = $session->{record};
	$args->{OFFSET}++;


}

sub fetch_a_record {
	my ($dbh,@key) = @_;
	my $sheet_id = shift @key;
	my $code_obs = shift @key;
	my $sql = "SELECT gabarit_name
	 	FROM MTD_VALUE
	  	WHERE (mtd_sheet_id = $sheet_id)
	   	AND (code_observatoire LIKE '$code_obs');";
	my $sth = $dbh->prepare($sql);
	$sth->execute();
	my $gabarit = $sth->fetchrow();
	$sql = "SELECT ga.elmnt_mtd_id
	 	FROM elmnt_mtd mt, elmnt_gabarit ga
		WHERE mt.data_type_code = 'racine'
		AND ga.gabarit_name = '$gabarit'
		 AND ga.elmnt_mtd_id=mt.elmnt_mtd_id";
	$sth = $dbh->prepare($sql);
	$sth->execute();
	my $racine = $sth->fetchrow();

	$session->{record}="<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>
<!DOCTYPE metadata SYSTEM \"http://MDweb.roselt-oss.org/xml/dtd/roselt_".$gabarit.".dtd\">\n";
	parcoursGab($gabarit,$sheet_id,$code_obs,$racine,0,"rubrique");
	#warn "envoy : $session->{record}";

}

sub parcoursGab {
	my ($gabarit,$sheet_id,$code_obs,$elmnt_mtd_id,$tab,$typeElt,$numEltPere) = @_;
	my $dbh = $session->{dbh};
	my $indent = "";
	for(my $i=0;$i<$tab;$i++){
		$indent .= "\t";
	}
	my $iso_name = isoName($elmnt_mtd_id,$dbh);
	my $a_des_fils = 0;
	if ($typeElt ne "class" && $typeElt ne "rubrique"){
		my $sql2 = "SELECT list_short_name
			 FROM elmnt_mtd
	  		WHERE elmnt_mtd_id='$elmnt_mtd_id'";
		my $sth2 = $dbh->prepare($sql2);
		$sth2->execute();
		my $list_short_name = $sth2->fetchrow();
		my $sql3 = "SELECT mtd_value, num_elmnt
			 FROM mtd_value
	 		WHERE (mtd_sheet_id = $sheet_id)
	 		AND ( code_observatoire LIKE '$code_obs')
	 		AND ( elmnt_mtd_id = '$elmnt_mtd_id' );";
		#warn "$sql3\n";
		my $sth3 = $dbh->prepare($sql3);
		$sth3->execute();
		my $mdExist=0;
		my $i=0;
		while(my @values = $sth3->fetchrow()) {
			my $value=shift @values;
			my $numElt= shift @values;
			
			
			if ($iso_name eq "bgFileName"){
			#warn "elt name = $iso_name\n";
			#warn "num elt = $numElt\n";
			#warn "num pere = $numEltPere\n";
			}
			if ($numElt=~/$numEltPere/){
				$session->{record} .= $indent."<".$iso_name.">";
				if($list_short_name && !($list_short_name eq " ")) {
					 $session->{record} .= "<".$list_short_name." value=\"".$value."\"/>";
					 $session->{record} .= "</".$iso_name.">\n" ;
				}else{
					 $session->{record} .= $value."</".$iso_name.">\n";
				}
				$mdExist=1;
			}
			$i++;
		}
		if (!$mdExist){
			$session->{record} .= $indent ."<".$iso_name.">";
			$session->{record} .= "</".$iso_name.">\n"; 
		}
	}else{
		if($iso_name eq "metadata"){
			$session->{record} .= "<metadata xml:lang=\"fr\">\n";
			my $sql_1 = "SELECT elmnt_fils_id, ordre, data_type_code
				FROM est_contenu, elmnt_mtd
	 			WHERE (elmnt_pere_id='$elmnt_mtd_id')
	 			AND (gabarit_name 	LIKE '$gabarit')
	 			AND (est_contenu.elmnt_fils_id=elmnt_mtd.elmnt_mtd_id)
	 			ORDER BY ordre ASC;";
	  		my ($sth_1) = $dbh->prepare($sql_1);
			my ($nb)=$sth_1->execute();
			while(my @fils = $sth_1->fetchrow){
				my $elmnt_fils_id = $fils[0];
				my $ordre= $fils[1];
				my $type= $fils[2];
				parcoursGab($gabarit,$sheet_id,$code_obs,$elmnt_fils_id,$tab+1,$type,$numEltPere);
			}
			$session->{record} .=$indent ."</".$iso_name.">";
		}elsif($typeElt eq "rubrique"){
			my $sql4 = "SELECT num_elmnt_gab, max_occ_gab 
	 		FROM elmnt_gabarit
	 		WHERE (elmnt_mtd_id='$elmnt_mtd_id')
	 		AND gabarit_name='$gabarit'";
	 		my $sth4 = $dbh->prepare($sql4);
			$sth4->execute();
			my @num = $sth4->fetchrow();
			$numEltPere = shift @num;
			my $max_occ = shift @num;
			my $nb_rub;
			if ($max_occ>1){
				my $sql_rub="SELECT mtd_value
		 			FROM mtd_value
		 			WHERE mtd_sheet_id = $sheet_id
	 				AND code_observatoire LIKE '$code_obs'
	 				AND elmnt_mtd_id = '$elmnt_mtd_id'";
					#warn "$sql_rub\n";
 				my ($sth_rub) = $dbh->prepare($sql_rub);
				if($sth_rub->execute()!=0){
					my @rub=$sth_rub->fetchrow();
					$nb_rub= shift @rub;
				}else{
					$nb_rub= 1;
				}
			}else{
				$nb_rub= 1;
			}
			
			for (my $i=0;$i<$nb_rub;$i++){	
			
				$session->{record} .= $indent ."<".$iso_name.">\n";
				my $sql_2 = "SELECT elmnt_fils_id, ordre, data_type_code
					FROM est_contenu, elmnt_mtd
		 			WHERE (elmnt_pere_id='$elmnt_mtd_id')
		 			AND (gabarit_name 	LIKE '$gabarit')
	 				AND (est_contenu.elmnt_fils_id=elmnt_mtd.elmnt_mtd_id)
	 				ORDER BY ordre ASC;";
		  		my ($sth_2) = $dbh->prepare($sql_2);
				my ($nb)=$sth_2->execute();
				
				while(my @fils = $sth_2->fetchrow){
					my $elmnt_fils_id = $fils[0];
					my $ordre= $fils[1];
					my $type= $fils[2];
					parcoursGab($gabarit,$sheet_id,$code_obs,$elmnt_fils_id,$tab+1,$type,$numEltPere);
				}
				
				if ($nb_rub>1){
					$numEltPere=indiceSuivant($numEltPere);
				}
				$session->{record} .=$indent ."</".$iso_name.">\n";
			}
		}elsif ($typeElt eq "class" ){
			if ($iso_name eq "GeoDesc" || $iso_name eq "geoDesc"
											|| $iso_name eq "GeoBndBox" || $iso_name eq "geoBndBox"){
				$session->{record} .= $indent ."<".$iso_name.">";
			}elsif($iso_name eq "TM_Period"){
				$session->{record} .= $indent ."<TM_GeometricPrimitive>\n";
				$tab++;
				$indent .= "\t";
				$session->{record} .= $indent ."<".$iso_name.">\n";
			}
			my $sql_3 = "SELECT elmnt_fils_id, ordre, data_type_code
				FROM est_contenu, elmnt_mtd
	 			WHERE (elmnt_pere_id='$elmnt_mtd_id')
	 			AND (gabarit_name 	LIKE '$gabarit')
	 			AND (est_contenu.elmnt_fils_id=elmnt_mtd.elmnt_mtd_id)
	 			ORDER BY ordre ASC;";
	  		my ($sth_3) = $dbh->prepare($sql_3);
			my ($nb)=$sth_3->execute();
			my (@fils);
			while(@fils = $sth_3->fetchrow){
				#warn "@fils\n";
				$a_des_fils = 1;
				my $elmnt_fils_id = $fils[0];
				my $ordre= $fils[1];
				my $type= $fils[2];
				parcoursGab($gabarit,$sheet_id,$code_obs,$elmnt_fils_id,$tab+1,$type,$numEltPere);
				
			}
			if($iso_name eq "GeoDesc" || $iso_name eq "geoDesc" || $iso_name eq "GeoBndBox" || $iso_name eq "geoBndBox"){
				$session->{record} .= $indent ."</".$iso_name.">\n";
			}elsif($iso_name eq "TM_Period"){
				$session->{record} .= $indent ."</".$iso_name.">\n";
				$tab--;
				$indent="";
				for(my $i=0;$i<$tab;$i++){
					$indent .= "\t";
				}
				$session->{record} .= $indent ."</TM_GeometricPrimitive>\n";
			}
			
		}
	}
}
sub indiceSuivant{
	my ($val)=@_;	
	my $dernChif=substr($val,-1,1);
	if ($dernChif eq 0){
		$dernChif="1";
	}elsif($dernChif eq 9){
		$dernChif="a";
	}elsif($dernChif eq "z"){
		$dernChif="A";
	}elsif($dernChif eq "Z"){
		$dernChif="/";
	}elsif($dernChif eq "/"){
		$dernChif="/";
	}else{
		$dernChif++;
	}
	$val=substr($val,0,-1).$dernChif;
	return $val;
		
}

sub isoName{
	my ($element,$dbh) = @_;
	my $sql = "SELECT elmnt_short_name
	 FROM elmnt_mtd
	  WHERE elmnt_mtd_id = '$element'";
	my $sth = $dbh->prepare($sql);
	$sth->execute();
	return $sth->fetchrow_array();
}

package Net::Z3950::RPN::And;
sub SQLcond {
    my $this = shift;
    return "(". $this->[0]->SQLcond(@_) . " AND " .
		  $this->[1]->SQLcond(@_) . ")";
}
package Net::Z3950::RPN::Or;
sub SQLcond {
    my $this = shift;
    return "(" . $this->[0]->SQLcond(@_) . " OR " .
		  $this->[1]->SQLcond(@_) . ")";
}
package Net::Z3950::RPN::AndNot;
sub SQLcond {
    my $this = shift;
    return "(" . $this->[0]->SQLcond(@_) . " AND NOT "  .
		  $this->[1]->SQLcond(@_) . ")";
}

package Net::Z3950::RPN::Term;
sub SQLcond {
	my $dbh = $session->{dbh};
	my $this = shift;
	my %attributes;
	my $relation;
	foreach my $attr (@{ $this->{attributes} }) {
		# There's no diagnostic for multiple attributes of the same type, so we just ignore them
		my $type = $attr->{attributeType};
		$attributes{$type} = $attr;
	}
	my $use = $attributes{1};
	my $attributeSet;
	# Use attribute required but not supplied
	#if !defined $use;
	my $val = $use->{attributeValue};
	$attributeSet = $use->{attributeSet} if defined $use->{attributeSet};
	$relation = relation($attributeSet, \%attributes);
	#warn "relation = $relation\n";
	my $term = term($attributeSet, \%attributes, $this->{term});
	#	We're completely ignoring position (3), structure (4) and
	#	completeness (5) attributes, in part because I don't honestly
	#	feel 100% that I know what they mean.
	if ($term =~ /%/) {
		# What does it mean to search (e.g.) < left-truncated term?
		# if ($relation ne "="){...};
		$relation = "LIKE";
	}
	my $strRes;
	my $i;
	$i=0;
	my $sql1 = "SELECT champ_mdweb,table_mdweb  
			FROM map_z3950_mdweb
			WHERE num_attrib_z3950='$val'";
	my $sth1 = $dbh->prepare($sql1);
	#warn "$sql1\n";
	$sth1->execute();
	$strRes ="(";
	my $index=index($term,"'");
	if ($index!=-1){
		substr($term,$index,1)="\\'";
	}
	while(my @res = $sth1->fetchrow()){
		my $attribut = shift @res;
		my $table= shift @res;
		#warn "attribut = $attribut\n";
		#warn "table = $table\n";
		if ($i>0){
			$strRes .=" OR ";
		}
		$i++;	
	
		if ($table eq "index"){
			$strRes .=" ind.".$attribut . " " . $relation . " '" . $term."'";
		}elsif($table eq "md_og"){
			$session->{criteres}->{empco} = 1;
			$strRes .=" empco.".$attribut . " ".$relation ." '" . $term."'";
		}elsif($table eq "mots_cles"){
			$session->{criteres}->{mo} = 1;
			$strRes .="(mo.libelle LIKE '".$term."' AND mo.nom_thesaurus LIKE '".$attribut."')";
		}
	}
	$strRes .=")";
	return $strRes;
}

sub relation {
    my($attributeSet, $attributes) = @_;
    ### Should check for utility-set attributes as well as BIB-1
    my $attr = $attributes->{2};
    return "=" if !defined $attr;
    my $val = $attr->{attributeValue};
    my @rel = qw(< <= = >= > <>);
    my $rel = $rel[$val-1];
    #if (!defined $rel) {...};
    return $rel;
}

sub term {
    my($attributeSet, $attributes, $rawterm) = @_;
    ### Should check for utility-set attributes as well as BIB-1
    my $attr = $attributes->{5};
    return $rawterm if !defined $attr;
    my $val = $attr->{attributeValue};
    if ($val == 1) {
		return $rawterm . "%";
    }elsif ($val == 2) {
		return "%" . $rawterm;
    }elsif ($val == 3) {
		return "%" . $rawterm . "%";
    }elsif ($val == 100) {
		return $rawterm;
    }elsif ($val == 101) {
	$rawterm =~ tr/#/%/;
		return $rawterm;
    }
}

